DATA data1;
DO t=-5000 TO 5000;
nu=t/1000;
pi=3.14;
W=1;
Wk=(1/(2*pi))*(sin((5+0.5)*nu))/(sin(nu/2));
OUTPUT data1;
END;
RUN;
 
/*
PROC PRINT;
VAR nu Wk;
RUN; */

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=spline ci=black; 

PROC GPLOT; 
PLOT W*nu=3/GRID FRAME HREF=0 VAXIS=0  TO 1.5 BY 0.2 HAXIS=-10 TO 10 BY 5;
symbol c=black v=line i=join;
RUN;


PROC GPLOT; 
PLOT Wk*nu=3/GRID FRAME HREF=0 VREF=0 VAXIS=-0.5  TO 2 BY 0.2 HAXIS=-4 TO 4 BY 1;
symbol c=black v=line i=join;
RUN;