DATA INCOMEDATA;
INFILE 'G:\FSAScodedata_2010\INCOMES0.dat'; 
INPUT x1 x2 x3 x4 x5@@;
t=_N_;

x1=(x1-1684.61)/(4191.43-1684.61);  /* normalization of data */  
x2=(x2-1684.61)/(4191.43-1684.61);
x3=(x3-1684.61)/(4191.43-1684.61);
x4=(x4-1684.61)/(4191.43-1684.61);
x5=(x5-1684.61)/(4191.43-1684.61);

/* x1=log(x1); x2=log(x2); x3=log(x3); x4=log(x4); x5=log(x5); not nece */

y=x5;     /* target value */

IF t>=108 THEN DELETE; 
k=1;
                            
eta=0.01; /* 0.05 1.19 0.01 1.0 eta=1.2; */
/* UNIFORM RANDOM NUMBERS for weights and biases */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_12=-UNIFORM(3+k)/10; ELSE w1_12=UNIFORM(3+k)/10;
IF UNIFORM(4+k)<=0.5 THEN w1_22=-UNIFORM(4+k)/10; ELSE w1_22=UNIFORM(4+k)/10;
IF UNIFORM(5+k)<=0.5 THEN w1_13=-UNIFORM(5+k)/10; ELSE w1_13=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN w1_23=-UNIFORM(6+k)/10; ELSE w1_23=UNIFORM(6+k)/10;
IF UNIFORM(7+k)<=0.5 THEN w1_14=-UNIFORM(7+k)/10; ELSE w1_14=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w1_24=-UNIFORM(8+k)/10; ELSE w1_24=UNIFORM(8+k)/10;
IF UNIFORM(9+k)<=0.5 THEN w1_15=-UNIFORM(9+k)/10; ELSE w1_15=UNIFORM(9+k)/10;
IF UNIFORM(10+k)<=0.5 THEN w1_25=-UNIFORM(10+k)/10; ELSE w1_25=UNIFORM(10+k)/10;
IF UNIFORM(11+k)<=0.5 THEN w1_16=-UNIFORM(11+k)/10; ELSE w1_16=UNIFORM(11+k)/10;
IF UNIFORM(12+k)<=0.5 THEN w1_26=-UNIFORM(12+k)/10; ELSE w1_26=UNIFORM(12+k)/10;
IF UNIFORM(13+k)<=0.5 THEN w1_17=-UNIFORM(13+k)/10; ELSE w1_17=UNIFORM(13+k)/10;
IF UNIFORM(14+k)<=0.5 THEN w1_27=-UNIFORM(14+k)/10; ELSE w1_27=UNIFORM(14+k)/10;
IF UNIFORM(15+k)<=0.5 THEN w1_18=-UNIFORM(15+k)/10; ELSE w1_18=UNIFORM(15+k)/10;
IF UNIFORM(16+k)<=0.5 THEN w1_28=-UNIFORM(16+k)/10; ELSE w1_28=UNIFORM(16+k)/10;

/* FIRST LINEAR TRANSFORMATION */
z1=w1_11*x1+w1_21*x4;  z2=w1_12*x1+w1_22*x4; 
z3=w1_13*x1+w1_23*x4;  z4=w1_14*x1+w1_24*x4; 
z5=w1_15*x1+w1_25*x4;  z6=w1_16*x1+w1_26*x4; 
z7=w1_17*x1+w1_27*x4;  z8=w1_18*x1+w1_28*x4; 

/* FIRST ACTIVITY FUNCTION */
IF UNIFORM(17+k)<=0.5 THEN b1=-UNIFORM(17+k)/10; ELSE b1=UNIFORM(17+k)/10;
IF UNIFORM(18+k)<=0.5 THEN b2=-UNIFORM(18+k)/10; ELSE b2=UNIFORM(18+k)/10;
IF UNIFORM(19+k)<=0.5 THEN b3=-UNIFORM(19+k)/10; ELSE b3=UNIFORM(19+k)/10;
IF UNIFORM(20+k)<=0.5 THEN b4=-UNIFORM(20+k)/10; ELSE b4=UNIFORM(20+k)/10;
IF UNIFORM(21+k)<=0.5 THEN b5=-UNIFORM(21+k)/10; ELSE b5=UNIFORM(21+k)/10; 
IF UNIFORM(22+k)<=0.5 THEN b6=-UNIFORM(22+k)/10; ELSE b6=UNIFORM(22+k)/10;
IF UNIFORM(23+k)<=0.5 THEN b7=-UNIFORM(23+k)/10; ELSE b7=UNIFORM(23+k)/10;
IF UNIFORM(24+k)<=0.5 THEN b8=-UNIFORM(24+k)/10; ELSE b8=UNIFORM(24+k)/10;

s1=1/(1+exp(-(z1+b1))); s2=1/(1+exp(-(z2+b2)));
s3=1/(1+exp(-(z3+b3))); s4=1/(1+exp(-(z4+b4)));   
s5=1/(1+exp(-(z5+b5))); s6=1/(1+exp(-(z6+b6)));
s7=1/(1+exp(-(z7+b7))); s8=1/(1+exp(-(z8+b8)));   

/* SECOND LINEAR TRANSFORMATION */ 

IF UNIFORM(25+k)<=0.5 THEN w2_11=-UNIFORM(25+k)/10; ELSE w2_11=UNIFORM(25+k)/10;
IF UNIFORM(26+k)<=0.5 THEN w2_21=-UNIFORM(26+k)/10; ELSE w2_21=UNIFORM(26+k)/10;
IF UNIFORM(41+k)<=0.5 THEN w2_31=-UNIFORM(41+k)/10; ELSE w2_31=UNIFORM(41+k)/10;
IF UNIFORM(42+k)<=0.5 THEN w2_41=-UNIFORM(42+k)/10; ELSE w2_41=UNIFORM(42+k)/10;
IF UNIFORM(43+k)<=0.5 THEN w2_51=-UNIFORM(43+k)/10; ELSE w2_51=UNIFORM(43+k)/10;
IF UNIFORM(44+k)<=0.5 THEN w2_61=-UNIFORM(44+k)/10; ELSE w2_61=UNIFORM(44+k)/10;
IF UNIFORM(45+k)<=0.5 THEN w2_71=-UNIFORM(45+k)/10; ELSE w2_71=UNIFORM(45+k)/10;
IF UNIFORM(46+k)<=0.5 THEN w2_81=-UNIFORM(46+k)/10; ELSE w2_81=UNIFORM(46+k)/10;

z9=w2_11*s1+w2_21*s2+w2_31*s3+w2_41*s4+w2_51*s5+w2_61*s6+w2_71*s7+w2_81*s8;

IF UNIFORM(47+k)<=0.5 THEN b9=-UNIFORM(47+k)/10; ELSE b9=UNIFORM(47+k)/10;

/* FIRST ESTIMATED VALUE */ 
s9=1/(1+exp(-(z9+b9)));
y_hat=s9;  

/* proc print; var b8 z1 s1 s2 z9 s9 y_hat; 
run; */

/* 1ST BACKPROPAGATION step 1(right hand size) */
pLpw2_11=-2*(y-y_hat)*s9*(1-s9)*s1;
pLpw2_21=-2*(y-y_hat)*s9*(1-s9)*s2;
pLpw2_31=-2*(y-y_hat)*s9*(1-s9)*s3;
pLpw2_41=-2*(y-y_hat)*s9*(1-s9)*s4;
pLpw2_51=-2*(y-y_hat)*s9*(1-s9)*s5;
pLpw2_61=-2*(y-y_hat)*s9*(1-s9)*s6;
pLpw2_71=-2*(y-y_hat)*s9*(1-s9)*s7;
pLpw2_81=-2*(y-y_hat)*s9*(1-s9)*s8;

pLpb9=-2*(y-y_hat)*(s9*(1-s9))*1;

/* new wights ws_11 etc p13 */
w2_11=w2_11-eta*pLpw2_11; w2_21=w2_21-eta*pLpw2_21; 
w2_31=w2_31-eta*pLpw2_31; w2_41=w2_41-eta*pLpw2_41;
w2_51=w2_51-eta*pLpw2_51; w2_61=w2_61-eta*pLpw2_61; 
w2_71=w2_71-eta*pLpw2_71; w2_81=w2_81-eta*pLpw2_81;

b9=b9-eta*pLpb9;  

/* BACKPROPAGATION step 2(left hand size) */
pLpw1_11=-2*(y-y_hat)*(w2_11*s9*(1-s9))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y_hat)*(w2_11*s9*(1-s9))*(x4*s1*(1-s1));
pLpw1_12=-2*(y-y_hat)*(w2_21*s9*(1-s9))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y_hat)*(w2_21*s9*(1-s9))*(x4*s2*(1-s2));
pLpw1_13=-2*(y-y_hat)*(w2_31*s9*(1-s9))*(x1*s3*(1-s3));
pLpw1_23=-2*(y-y_hat)*(w2_31*s9*(1-s9))*(x4*s3*(1-s3));
pLpw1_14=-2*(y-y_hat)*(w2_41*s9*(1-s9))*(x1*s4*(1-s4));
pLpw1_24=-2*(y-y_hat)*(w2_41*s9*(1-s9))*(x4*s4*(1-s4));
pLpw1_15=-2*(y-y_hat)*(w2_51*s9*(1-s9))*(x1*s5*(1-s5));
pLpw1_25=-2*(y-y_hat)*(w2_51*s9*(1-s9))*(x4*s5*(1-s5));
pLpw1_16=-2*(y-y_hat)*(w2_61*s9*(1-s9))*(x1*s6*(1-s6));
pLpw1_26=-2*(y-y_hat)*(w2_61*s9*(1-s9))*(x4*s6*(1-s6));
pLpw1_17=-2*(y-y_hat)*(w2_71*s9*(1-s9))*(x1*s7*(1-s7));
pLpw1_27=-2*(y-y_hat)*(w2_71*s9*(1-s9))*(x4*s7*(1-s7));
pLpw1_18=-2*(y-y_hat)*(w2_81*s9*(1-s9))*(x1*s8*(1-s8));
pLpw1_28=-2*(y-y_hat)*(w2_81*s9*(1-s9))*(x4*s8*(1-s8));

pLpb_1=-2*(y-y_hat)*(w2_11*s9*(1-s9))*(1*s1*(1-s1));  
pLpb_2=-2*(y-y_hat)*(w2_21*s9*(1-s9))*(1*s2*(1-s2));
pLpb_3=-2*(y-y_hat)*(w2_31*s9*(1-s9))*(1*s3*(1-s3)); 
pLpb_4=-2*(y-y_hat)*(w2_41*s9*(1-s9))*(1*s4*(1-s4));
pLpb_5=-2*(y-y_hat)*(w2_51*s9*(1-s9))*(1*s5*(1-s5));  
pLpb_6=-2*(y-y_hat)*(w2_61*s9*(1-s9))*(1*s6*(1-s6));
pLpb_7=-2*(y-y_hat)*(w2_71*s9*(1-s9))*(1*s7*(1-s7));  
pLpb_8=-2*(y-y_hat)*(w2_81*s9*(1-s9))*(1*s8*(1-s8));

/* SECOND STEP UPDATED WEIGHTS */
w1_11=w1_11-eta*pLpw1_11; w1_21=w1_21-eta*pLpw1_21;
w1_12=w1_12-eta*pLpw1_12; w1_22=w1_22-eta*pLpw1_22;
w1_13=w1_13-eta*pLpw1_13; w1_23=w1_23-eta*pLpw1_23;
w1_14=w1_14-eta*pLpw1_14; w1_24=w1_24-eta*pLpw1_24;
w1_15=w1_15-eta*pLpw1_15; w1_25=w1_25-eta*pLpw1_25;
w1_16=w1_16-eta*pLpw1_16; w1_26=w1_26-eta*pLpw1_26;
w1_17=w1_17-eta*pLpw1_17; w1_27=w1_27-eta*pLpw1_27;
w1_18=w1_18-eta*pLpw1_18; w1_28=w1_28-eta*pLpw1_28;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb_1;                                    
b2=b2-eta*pLpb_2; 
b3=b3-eta*pLpb_3;                                     
b4=b4-eta*pLpb_4; 
b5=b5-eta*pLpb_5;                                    
b6=b6-eta*pLpb_6; 
b7=b7-eta*pLpb_7;                                     
b8=b8-eta*pLpb_8; 

z1=w1_11*x1+w1_21*x4;
z2=w1_12*x1+w1_22*x4;
z3=w1_13*x1+w1_23*x4;
z4=w1_14*x1+w1_24*x4;
z5=w1_15*x1+w1_25*x4;
z6=w1_16*x1+w1_26*x4;
z7=w1_17*x1+w1_27*x4;
z8=w1_18*x1+w1_28*x4;

s1=1/(1+exp(-(z1+b1)));  
s2=1/(1+exp(-(z2+b2)));
s3=1/(1+exp(-(z3+b3)));
s4=1/(1+exp(-(z4+b4)));
s5=1/(1+exp(-(z5+b5)));  
s6=1/(1+exp(-(z6+b6)));
s7=1/(1+exp(-(z7+b7)));
s8=1/(1+exp(-(z8+b8)));

z9=w2_11*s1+w2_21*s2+w2_31*s3+w2_41*s4
   +w2_51*s5+w2_61*s6+w2_71*s7+w2_81*s8;

s9=1/(1+exp(-(z9+b9)));
y1_hat=s9; 

/* proc print; var b8s zs1 ss1 ss2 zs9 ss9 y1_hat; 
run; */
               x=1; 
               DO WHILE(x<=1000); 
/* 2ND BACKPROPAGATION step 1(right hand size) */

pLpw2_11=-2*(y-y_hat)*s9*(1-s9)*s1;
pLpw2_21=-2*(y-y_hat)*s9*(1-s9)*s2;
pLpw2_31=-2*(y-y_hat)*s9*(1-s9)*s3;
pLpw2_41=-2*(y-y_hat)*s9*(1-s9)*s4;
pLpw2_51=-2*(y-y_hat)*s9*(1-s9)*s5;
pLpw2_61=-2*(y-y_hat)*s9*(1-s9)*s6;
pLpw2_71=-2*(y-y_hat)*s9*(1-s9)*s7;
pLpw2_81=-2*(y-y_hat)*s9*(1-s9)*s8;

pLpb9=-2*(y-y1_hat)*(s9*(1-s9))*1;

/* new wights ws_11 etc p13 */
w2_11=w2_11-eta*pLpw2_11; w2_21=w2_21-eta*pLpw2_21; 
w2_31=w2_31-eta*pLpw2_31; w2_41=w2_41-eta*pLpw2_41;
w2_51=w2_51-eta*pLpw2_51; w2_61=w2_61-eta*pLpw2_61; 
w2_71=w2_71-eta*pLpw2_71; w2_81=w2_81-eta*pLpw2_81;

b9=b9-eta*pLpb9;  

/* BACKPROPAGATION step 2(left hand size) */

pLpw1_11=-2*(y-y1_hat)*(w2_11*s9*(1-s9))*(x1*s1*(1-s1));
pLpw1_21=-2*(y-y1_hat)*(w2_11*s9*(1-s9))*(x4*s1*(1-s1));
pLpw1_12=-2*(y-y1_hat)*(w2_21*s9*(1-s9))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y1_hat)*(w2_21*s9*(1-s9))*(x4*s2*(1-s2));
pLpw1_13=-2*(y-y1_hat)*(w2_31*s9*(1-s9))*(x1*s3*(1-s3));
pLpw1_23=-2*(y-y1_hat)*(w2_31*s9*(1-s9))*(x4*s3*(1-s3));
pLpw1_14=-2*(y-y1_hat)*(w2_41*s9*(1-s9))*(x1*s4*(1-s4));
pLpw1_24=-2*(y-y1_hat)*(w2_41*s9*(1-s9))*(x4*s4*(1-s4));
pLpw1_15=-2*(y-y1_hat)*(w2_51*s9*(1-s9))*(x1*s5*(1-s5));
pLpw1_25=-2*(y-y1_hat)*(w2_51*s9*(1-s9))*(x4*s5*(1-s5));
pLpw1_16=-2*(y-y1_hat)*(w2_61*s9*(1-s9))*(x1*s6*(1-s6));
pLpw1_26=-2*(y-y1_hat)*(w2_61*s9*(1-s9))*(x4*s6*(1-s6));
pLpw1_17=-2*(y-y1_hat)*(w2_71*s9*(1-s9))*(x1*s7*(1-s7));
pLpw1_27=-2*(y-y1_hat)*(w2_71*s9*(1-s9))*(x4*s7*(1-s7));
pLpw1_18=-2*(y-y1_hat)*(w2_81*s9*(1-s9))*(x1*s8*(1-s8));
pLpw1_28=-2*(y-y1_hat)*(w2_81*s9*(1-s9))*(x4*s8*(1-s8));

pLpb_1=-2*(y-y1_hat)*(w2_11*s9*(1-s9))*(1*s1*(1-s1));
pLpb_2=-2*(y-y1_hat)*(w2_21*s9*(1-s9))*(1*s2*(1-s2));
pLpb_3=-2*(y-y1_hat)*(w2_31*s9*(1-s9))*(1*s3*(1-s3));
pLpb_4=-2*(y-y1_hat)*(w2_41*s9*(1-s9))*(1*s4*(1-s4));
pLpb_5=-2*(y-y1_hat)*(w2_51*s9*(1-s9))*(1*s5*(1-s5));
pLpb_6=-2*(y-y1_hat)*(w2_61*s9*(1-s9))*(1*s6*(1-s6));
pLpb_7=-2*(y-y1_hat)*(w2_71*s9*(1-s9))*(1*s7*(1-s7));
pLpb_8=-2*(y-y1_hat)*(w2_81*s9*(1-s9))*(1*s8*(1-s8));

/* SECOND STEP UPDATED WEIGHTS  */
w1_11=w1_11-eta*pLpw1_11; w1_21=w1_21-eta*pLpw1_21;
w1_12=w1_12-eta*pLpw1_12; w1_22=w1_22-eta*pLpw1_22;
w1_13=w1_13-eta*pLpw1_13; w1_23=w1_23-eta*pLpw1_23;
w1_14=w1_14-eta*pLpw1_14; w1_24=w1_24-eta*pLpw1_24;
w1_15=w1_15-eta*pLpw1_15; w1_25=w1_25-eta*pLpw1_25;
w1_16=w1_16-eta*pLpw1_16; w1_26=w1_26-eta*pLpw1_26;
w1_17=w1_17-eta*pLpw1_17; w1_27=w1_27-eta*pLpw1_27;
w1_18=w1_18-eta*pLpw1_18; w1_28=w1_28-eta*pLpw1_28;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb_1; b2=b2-eta*pLpb_2;
b3=b3-eta*pLpb_3; b4=b4-eta*pLpb_4;
b5=b5-eta*pLpb_5; b6=b6-eta*pLpb_6;
b7=b7-eta*pLpb_7; b8=b8-eta*pLpb_8;

z1=w1_11*x1+w1_21*x4; z2=w1_12*x1+w1_22*x4;
z3=w1_13*x1+w1_23*x4; z4=w1_14*x1+w1_24*x4;
z5=w1_15*x1+w1_25*x4; z6=w1_16*x1+w1_26*x4;
z7=w1_17*x1+w1_27*x4; z8=w1_18*x1+w1_28*x4;
 
s1=1/(1+exp(-(z1+b1)));  
s2=1/(1+exp(-(z2+b2)));
s3=1/(1+exp(-(z3+b3)));
s4=1/(1+exp(-(z4+b4)));
s5=1/(1+exp(-(z5+b5)));  
s6=1/(1+exp(-(z6+b6)));
s7=1/(1+exp(-(z7+b7)));
s8=1/(1+exp(-(z8+b8)));

z9=w2_11*s1+w2_21*s2+w2_31*s3+w2_41*s4
   +w2_51*s5+w2_61*s6+w2_71*s7+w2_81*s8;

s9=1/(1+exp(-(z9+b9)));
y2_hat=s9; 

Rx1=x1*(4191.43-1684.61)+1684.61;
Ry=y*(4191.43-1684.61)+1684.61;
Ry_hat=y_hat*(4191.43-1684.61)+1684.61;
Ry1_hat=y1_hat*(4191.43-1684.61)+1684.61;
Ry2_hat=y2_hat*(4191.43-1684.61)+1684.61; 
 
MSE=(y-y_hat)**2;                       
MSE1=(y-y1_hat)**2;                     
MSE2=(y-y2_hat)**2;

MAE=ABS(y-y_hat);
MAE1=ABS(y-y1_hat);
MAE2=ABS(y-y2_hat);

MASE_aa=ABS(y-lag4(y));
MASE=MAE/0.0408944;      /* x=1: MASE_aa=0.0408944   */   
MASE1=MAE1/0.0337169;    /* x=10: MASE_aa=0.0337169   */ 
MASE2=MAE2/0.000335921;    /* x=100: MASE_aa=0.0033603 */  
                         /* x=500: MASE_aa=0.000671866 */  
                         /* x=1000: MASE_aa=0.000335921 */  
                         /* x=2: MASE_aa=0.0933027 */  
RMSE=SQRT(MSE);
RMSE1=SQRT(MSE1);
RMSE2=SQRT(MSE2);


IF y=0 THEN y=0.001;
MPE=((y-y_hat)/y)*100;
MPE1=((y-y1_hat)/y)*100;
MPE2=((y-y2_hat)/y)*100; 

MAPE=(ABS(y-y_hat)/y)*100;
MAPE1=(ABS(y-y1_hat)/y)*100;
MAPE2=(ABS(y-y2_hat)/y)*100; 

             OUTPUT;
             x+1;
             END; 
             RUN;  

/* IF x<1 THEN DELETE; */
/* PROC PRINT; VAR t x y_hat y1_hat y2_hat;
RUN; */

/*
PROC PRINT; VAR MASE_aa;
RUN; */

PROC MEANS;	VAR MASE_aa;
RUN; 

PROC MEANS; VAR MSE MSE1 MSE2;
RUN;

PROC MEANS; VAR MASE MASE1 MASE2;
RUN;

PROC MEANS; VAR MAE MAE1 MAE2;
RUN;

PROC MEANS; VAR MPE MPE1 MPE2;
RUN;

PROC MEANS; VAR MAPE MAPE1 MAPE2;
RUN;

DATA NEW1;
SET INCOMEDATA; 

/* x1=exp(x1); x2=exp(x2); x3=exp(x3); x4=exp(x4); */
 
SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

/*
PROC GPLOT DATA=INCOMEDATA;   
PLOT y*t=4 y_hat*t=1 y1_hat*t=2 y2_hat*t=3 /OVERLAY legend GRID FRAME HREF=97.5;
RUN;

PROC GPLOT DATA=INCOMEDATA;   
PLOT y*t=4 y_hat*t=2 y1_hat*t=3 /OVERLAY legend GRID FRAME HREF=97.5;
RUN;

PROC GPLOT DATA=INCOMEDATA;   
PLOT y*t=1 y1_hat*t=2 /OVERLAY 
legend GRID FRAME HREF=97.5; 
RUN;

PROC GPLOT DATA=INCOMEDATA;   
PLOT y*t=1 y2_hat*t=3 /OVERLAY 
legend GRID FRAME HREF=97.5; 
RUN; 
*/


/* MASE_aa=0.2834393; MASE_aa1=0.1658799;  MASE_aa2=0.0324773; */