DATA FREIGHTDATA;
INFILE 'G:\BOX-ANN\FREIGHT2.dat'; 
INPUT FREIGHT MONTH QUART $ SEASON $;  
t=_N_;
lnF=log(FREIGHT);
run; 

SYMBOL1 v=dot  cv=black i=spline ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=spline ci=black; 

/* PROC PRINT; VAR FREIGHT MONTH QUART SEASON lnF DlnF;
RUN; */

proc gplot data=FREIGHTDATA;
plot FREIGHT*t/ vref=0 grid frame;
run;

proc gplot data=FREIGHTDATA;
plot lnF*t/ vref=0 grid frame;
run;

PROC ARIMA DATA=FREIGHTDATA; 
IDENTIFY VAR=lnF NLAG=36;
RUN;

PROC ARIMA DATA=FREIGHTDATA; 
IDENTIFY VAR=lnF NLAG=36;
ESTIMATE p=1 PLOT ML;
RUN;

PROC ARIMA; 
IDENTIFY VAR=lnF NLAG=36;
ESTIMATE p=2;
RUN;




/*
INPUT MON $ DAY YR PRICE OP HI LO VOL @@;
t1=_N_; 
TIME=_N_; 
t=337-(t1-1); 

PROC SORT DATA=data1 OUT=data2; by t; 

PROC PRINT DATA=data2; 

DATA data3;
SET data2; 
logP=log(PRICE);

logreturn=dif1(logP);                         
volatility=ABS(logreturn);
RUN;

PROC GPLOT DATA=FREIGHT; 
SYMBOL1 v=dot cv=black l=1 color=red;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=spline ci=black;
PLOT PRICE*TIME=4/OVERLAY GRID FRAME VAXIS=40 TO 60 BY 5 HAXIS=1 TO 337 BY 10;
RUN;

PROC GPLOT; 
PLOT logreturn*TIME=4/VREF=0 OVERLAY GRID FRAME VAXIS=-0.1 TO 0.1 BY 0.01
HAXIS=1 TO 337 BY 10;
RUN;

PROC UNIVARIATE NORMAL;
VAR logreturn;
PROBPLOT;
RUN; 

PROC ARIMA DATA=DATA3; 
IDENTIFY VAR=logreturn;
RUN;

PROC ARIMA DATA=DATA3; 
IDENTIFY VAR=logreturn;
ESTIMATE p=1 PLOT ML;
RUN;

PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=2;
RUN;

PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=3;
RUN;

PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=4;
RUN;

PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=5;
RUN;

PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=6;
RUN;

PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=7;
RUN;

PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=8;
RUN;

PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE q=1;
RUN;
         
PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE q=2;
RUN;
     
PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=1 q=1;
RUN;
 
PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=2 q=1;
RUN;              
              
PROC ARIMA; 
IDENTIFY VAR=logreturn;
ESTIMATE p=1 PLOT ML;
FORECAST OUT=OUTA;
FORECAST LEAD=4; 
RUN;

*/
/* return=(PRICE-dif1(PRICE))/dif1(PRICE); */ 
/* INFILE 'G:\FSAScodedata_2010\passenger.dat';  
INPUT FREIGHT 1-5 MONTH 6-7 QUART $ 8-11 SEASON $ 12-15;
 
proc gplot data=FREIGHTDATA;
plot FREIGHT*date/haxis='01jan69'd to '01dec78'd by year
	 href='01jan76'd vref=0 grid frame;
run;*/ 
quit;