DATA FREIGHT;
INFILE 'F:\NSAScodedata\FREIGHT4NOEXT.dat';  /* FREIGHT4NO.dat */
INPUT F M Q S Ftarget;                  /* F=FREIGHT M=month Q=quarter S=season  */
t=_N_; 

F=log(F); Ftarget=log(Ftarget);
M=log(M); Q=log(Q); S=log(S);                           /* FOR CONSTANT VARIANCE */

/* F=F+0.1; M=M+0.1; Q=Q+0.1; S=S+0.1;*/

F=(F-7.0457766)/(7.9969904-7.0457766);                  /* ON [0,1] */
Ftarget=(Ftarget-7.0457766)/(7.9969904-7.0457766); 
M=(M-0)/(2.4849066-0);                                  /* ON [0,1] */
Q=(Q-0)/(1.3862944-0);   
S=(S-0)/(1.3862944-0);

/* IF M=0 THEN M=0.0001; */
x1=F; x2=M; x3=Q; x4=S;                                 /* x1=F; x12=M; */

y=Ftarget;                                              /* target value */

/* PROC PRINT; RUN; */

eta=6.303;  /* eta=6.303; 5.503; 1.403 eta=7.503; eta=5.503; eta=4.503; 1.05 0.05*/ 
k=1;
/* numbers of input values no144=132+12 */
/* UNIFORM RANDOM NUMBERS for weights and biases */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_31=-UNIFORM(3+k)/10; ELSE w1_31=UNIFORM(3+k)/10;
IF UNIFORM(4+k)<=0.5 THEN w1_41=-UNIFORM(4+k)/10; ELSE w1_41=UNIFORM(4+k)/10;
IF UNIFORM(5+k)<=0.5 THEN w1_12=-UNIFORM(5+k)/10; ELSE w1_12=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN w1_22=-UNIFORM(6+k)/10; ELSE w1_22=UNIFORM(6+k)/10;
IF UNIFORM(7+k)<=0.5 THEN w1_32=-UNIFORM(7+k)/10; ELSE w1_32=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w1_42=-UNIFORM(8+k)/10; ELSE w1_42=UNIFORM(8+k)/10;
z1=w1_11*x1+w1_21*x2+w1_31*x3+w1_41*x4;   
z2=w1_12*x1+w1_22*x2+w1_32*x3+w1_42*x4;

/* 2 random biases for first 2 activity functions */
IF UNIFORM(9+k)<=0.5 THEN b1=-UNIFORM(9+k)/10; ELSE b1=UNIFORM(9+k)/10;
IF UNIFORM(10+k)<=0.5 THEN b2=-UNIFORM(10+k)/10; ELSE b2=UNIFORM(10+k)/10;
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

IF UNIFORM(11+k)<=0.5 THEN w2_11=-UNIFORM(11+k)/10; ELSE w2_11=UNIFORM(11+k)/10;
IF UNIFORM(12+k)<=0.5 THEN w2_21=-UNIFORM(12+k)/10; ELSE w2_21=UNIFORM(12+k)/10;
IF UNIFORM(13+k)<=0.5 THEN w2_12=-UNIFORM(13+k)/10; ELSE w2_12=UNIFORM(13+k)/10;
IF UNIFORM(14+k)<=0.5 THEN w2_22=-UNIFORM(14+k)/10; ELSE w2_22=UNIFORM(14+k)/10;
z3=w2_11*s1+w2_21*s2;    

IF UNIFORM(15+k)<=0.5 THEN b3=-UNIFORM(15+k)/10; ELSE b3=UNIFORM(15+k)/10;
IF UNIFORM(16+k)<=0.5 THEN b4=-UNIFORM(16+k)/10; ELSE b4=UNIFORM(16+k)/10;
s3=1/(1+exp(-(z3+b3))); 

y1_hat=s3;     /* The 1st estimate: random estimator */
 
/* 1. BACKPROPAGATION step 1(right hand size) */  
/* for 1st BACKPROPAGATION NEW ADD */
pLpw2_11=-2*(y-y1_hat)*s3*(1-s3)*s1;  
pLpw2_21=-2*(y-y1_hat)*s3*(1-s3)*s2;   

pLpb3=-2*(y-y1_hat)*s3*(1-s3);      

/* 2. new wights ws_11 etc pp13-14 first line */
w2_11=w2_11-eta*pLpw2_11;    
w2_21=w2_21-eta*pLpw2_21;   

b3=b3-eta*pLpb3;        

/* 21. BACKPROPAGATION step 21(left hand size) from [18]-3-1.SAS */
pLpw1_11=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x1;  
pLpw1_21=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x2;  
pLpw1_31=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x3;  
pLpw1_41=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x4;  
pLpw1_12=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x1;
pLpw1_22=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x2;
pLpw1_32=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x3;
pLpw1_42=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x4;

pLpb2=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2);
pLpb1=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1);
     
/* SECOND STEP for UPDATED WEIGHTS */ 
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_31=w1_31-eta*pLpw1_31; 
w1_41=w1_41-eta*pLpw1_41;
w1_12=w1_12-eta*pLpw1_12;       
w1_22=w1_22-eta*pLpw1_22;     
w1_32=w1_32-eta*pLpw1_32; 
w1_42=w1_42-eta*pLpw1_42;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 
  
/* New values of z1, z2 */   
z1=w1_11*x1+w1_21*x2+w1_31*x3+w1_41*x4;   
z2=w1_12*x1+w1_22*x2+w1_32*x3+w1_42*x4;

s1=1/(1+exp(-(z1+b1)));   
s2=1/(1+exp(-(z2+b2)));  

z3=w2_11*s1+w2_21*s2;
s3=1/(1+exp(-(z3+b3)));
 
y2_hat=s3;     /* The 2nd estimate  */
         
/* 1. BACKPROPAGATION step 1(right hand size) */
pLpw2_11=-2*(y-y2_hat)*s3*(1-s3)*s1;  
pLpw2_21=-2*(y-y2_hat)*s3*(1-s3)*s2;   

pLpb3=-2*(y-y2_hat)*(b3*(1-b3))*1;      

/* 2. new wights ws_11 etc pp13-14 first line */
w2_11=w2_11-eta*pLpw2_11;    
w2_21=w2_21-eta*pLpw2_21;   

b3=b3-eta*pLpb3;        

/* 2. BACKPROPAGATION step 2(left hand size) */ 
pLpw1_11=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x1;  
pLpw1_21=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x2;  
pLpw1_31=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x3;  
pLpw1_41=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x4;  
pLpw1_12=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x1;
pLpw1_22=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x2;
pLpw1_32=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x3;
pLpw1_42=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x4;

pLpb1=-2*(y-y1_hat)*s3*(1-s3)*w2_11*s1*(1-s1);
pLpb2=-2*(y-y1_hat)*s3*(1-s3)*w2_21*s2*(1-s2);
     
/* SECOND STEP for UPDATED WEIGHTS */ 
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_31=w1_31-eta*pLpw1_31; 
w1_41=w1_41-eta*pLpw1_41;
w1_12=w1_12-eta*pLpw1_12;       
w1_22=w1_22-eta*pLpw1_22;     
w1_32=w1_32-eta*pLpw1_32; 
w1_42=w1_42-eta*pLpw1_42;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 

/* New values of z1,z2 */
z1=w1_11*x1+w1_21*x2+w1_31*x3+w1_41*x4;   
z2=w1_12*x1+w1_22*x2+w1_32*x3+w1_42*x4; 

/* new values of s1,s2 */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

/* new values of z3 */ 
z3=w2_11*s1+w2_21*s2;    

/* new values of s3 */
s3=1/(1+exp(-(z3+b3))); 
y3_hat=s3;     /* The 3rd estimate */

/* 1. BACKPROPAGATION step 1(right hand size) */
pLpw2_11=-2*(y-y3_hat)*s3*(1-s3)*s1;  
pLpw2_21=-2*(y-y3_hat)*s3*(1-s3)*s2;   

pLpb3=-2*(y-y3_hat)*(b3*(1-b3))*1;      

/* 2. new wights ws_11 etc pp13-14 first line */
w2_11=w2_11-eta*pLpw2_11;    
w2_21=w2_21-eta*pLpw2_21;   

b3=b3-eta*pLpb3;        

/* 2. BACKPROPAGATION step 3(left hand size) */
pLpw1_11=-2*(y-y3_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x1;  
pLpw1_21=-2*(y-y3_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x2;  
pLpw1_31=-2*(y-y3_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x3;  
pLpw1_41=-2*(y-y3_hat)*s3*(1-s3)*w2_11*s1*(1-s1)*x4;  
pLpw1_12=-2*(y-y3_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x1;
pLpw1_22=-2*(y-y3_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x2;
pLpw1_32=-2*(y-y3_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x3;
pLpw1_42=-2*(y-y3_hat)*s3*(1-s3)*w2_21*s2*(1-s2)*x4;

pLpb3=-2*(y-y2_hat)*s3*(1-s3);
pLpb2=-2*(y-y3_hat)*s3*(1-s3)*w2_21*s2*(1-s2);
pLpb1=-2*(y-y3_hat)*s3*(1-s3)*w2_11*s1*(1-s1);

/* SECOND STEP for UPDATED WEIGHTS */ 
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_31=w1_31-eta*pLpw1_31; 
w1_41=w1_41-eta*pLpw1_41;
w1_12=w1_12-eta*pLpw1_12;       
w1_22=w1_22-eta*pLpw1_22;     
w1_32=w1_32-eta*pLpw1_32; 
w1_42=w1_42-eta*pLpw1_42;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 

/* new values of z1,z2 */
z1=w1_11*x1+w1_21*x2+w1_31*x3+w1_41*x4;   
z2=w1_12*x1+w1_22*x2+w1_32*x3+w1_42*x4; 

/* new values of s1,s2 */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

/* new values of z3 */ 
z3=w2_11*s1+w2_21*s2;    

/* new values of s3 */
s3=1/(1+exp(-(z3+b3))); 
y4_hat=s3;               /* The 4th estimate */ 

                         /*  OUTPUT;
                             x+1;
                             END; 
                             RUN; */ 
DATA NEW1;
SET FREIGHT;

MSE1=(y-y1_hat)**2;                     
MSE2=(y-y2_hat)**2; 
MSE3=(y-y3_hat)**2;                     
MSE4=(y-y4_hat)**2;

MAE1=ABS(y-y1_hat);
MAE2=ABS(y-y2_hat);
MAE3=ABS(y-y3_hat);
MAE4=ABS(y-y4_hat);

MAPE1=(ABS((y-y1_hat)/y))*100;
MAPE2=(ABS((y-y2_hat)/y))*100;
MAPE3=(ABS((y-y3_hat)/y))*100;
MAPE4=(ABS((y-y4_hat)/y))*100;

proc print; var y y1_hat y2_hat y3_hat y4_hat;
run;

PROC MEANS DATA=NEW1; VAR MSE1 MSE2 MSE3 MSE4;
RUN;

PROC MEANS DATA=NEW1; VAR MAE1 MAE2 MAE3 MAE4;
RUN; 
 
PROC MEANS DATA=NEW1; VAR MAPE1 MAPE2 MAPE3 MAPE4;
RUN;

PROC MEANS; VAR y y1_hat y2_hat y3_hat y4_hat;
RUN; 
 
DATA NEW2;       
SET NEW1;

resid4=y-y4_hat;

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=NEW2;  
PLOT y4_hat*t=3 y*t=1/* y1_hat*t=2*/ /OVERLAY /* HREF=120 */ legend GRID FRAME; 
RUN;

PROC GPLOT DATA=NEW2;  
PLOT y3_hat*t=3 y*t=1/OVERLAY /* HREF=120 */ legend GRID FRAME; 
RUN;

PROC GPLOT DATA=NEW2;  
PLOT y2_hat*t=3 y*t=1/* y1_hat*t=2*/ /OVERLAY /* HREF=120 */ legend GRID FRAME; 
RUN;

PROC GPLOT DATA=NEW2;  
PLOT y1_hat*t=3 y*t=1/OVERLAY /* HREF=120 */ legend GRID FRAME; 
RUN;


PROC GPLOT DATA=NEW2;  
PLOT resid4*t=3 /OVERLAY HREF=120 legend GRID FRAME 
VREF=0 HREF=120 VAXIS=-1.0 TO 1.0 BY 0.1 HAXIS=0 TO 140 BY 10;  
RUN; 

                       /* Bring this part from SAS-[18]-3-1.SAS */
DATA NEW3;
SET NEW2;

F=F*(7.9969904-7.0457766)+7.0457766;               /* [0,1]> original unit */
Ftarget=Ftarget*(7.9969904-7.0457766)+7.0457766;
M=M*(2.4849066-0)+0;
Q=Q*(1.3862944-0)+0;
S=S*(1.3862944-0)+0;

y=y*(7.9969904-7.0457766)+7.0457766;           
y1_hat=y1_hat*(7.9969904-7.0457766)+7.0457766;   
y2_hat=y2_hat*(7.9969904-7.0457766)+7.0457766;  
y3_hat=y3_hat*(7.9969904-7.0457766)+7.0457766;  
y4_hat=y4_hat*(7.9969904-7.0457766)+7.0457766;   

error1=y-y1_hat;                            
error2=y-y2_hat; 
error3=y-y3_hat; 
error4=y-y4_hat;                                

oy=exp(y);                                     
oy1_hat=exp(y1_hat);                            
oy2_hat=exp(y2_hat);
oy3_hat=exp(y3_hat);
oy4_hat=exp(y4_hat); 

oerror1=oy-oy1_hat;                               
oerror2=oy-oy2_hat; 
oerror3=oy-oy3_hat; 
oerror4=oy-oy4_hat;                                

MSE1=(y-y1_hat)**2; MSE2=(y-y2_hat)**2; MSE3=(y-y3_hat)**2; MSE4=(y-y4_hat)**2; 
MAE1=ABS(y-y1_hat); MAE2=ABS(y-y2_hat); MAE3=ABS(y-y3_hat); MAE4=ABS(y-y4_hat); 

MAPE1=(ABS((y-y1_hat)/y))*100; MAPE2=(ABS((y-y2_hat)/y))*100; 
MAPE3=(ABS((y-y3_hat)/y))*100; MAPE4=(ABS((y-y4_hat)/y))*100; 

OMSE1=(oy-oy1_hat)**2; OMSE2=(oy-oy2_hat)**2; OMSE3=(oy-oy3_hat)**2; OMSE4=(oy-oy4_hat)**2;  
OMAE1=ABS(oy-oy1_hat); OMAE2=ABS(oy-oy2_hat); OMAE3=ABS(oy-oy3_hat); OMAE4=ABS(oy-oy4_hat);    

OMPE1=((oy-oy1_hat)/oy)*100; OMPE2=((oy-oy2_hat)/oy)*100; 
OMPE3=((oy-oy3_hat)/oy)*100; OMPE4=((oy-oy4_hat)/oy)*100; 

OMAPE1=(ABS((oy-oy1_hat)/oy))*100; OMAPE2=(ABS((oy-oy2_hat)/oy))*100;
OMAPE3=(ABS((oy-oy3_hat)/oy))*100; OMAPE4=(ABS((oy-oy4_hat)/oy))*100; 

PROC PRINT DATA=NEW3; VAR t oy oy1_hat oy2_hat oy3_hat oy4_hat; 
RUN;
PROC MEANS DATA=NEW3; VAR oy oy1_hat oy2_hat oy3_hat oy4_hat; 
RUN;

PROC MEANS DATA=NEW3; VAR error1 error2 error3 error4; 
RUN; 
PROC MEANS DATA=NEW3; VAR oerror1 oerror2 oerror3 oerror4;   
RUN; 

PROC MEANS DATA=NEW3; VAR MSE1 MSE2 MSE3 MSE4;         
RUN;
PROC MEANS DATA=NEW3; VAR MAE1 MAE2 MAE3 MAE4; 
RUN; 

PROC MEANS DATA=NEW3; VAR MAPE1 MAPE2 MAPE3 MAPE4; 
RUN;

PROC MEANS DATA=NEW3; VAR OMSE1 OMSE2 OMSE3 OMSE4;        
RUN;
PROC MEANS DATA=NEW3; VAR OMAE1 OMAE2 OMAE3 OMAE4; 
RUN; 

PROC MEANS DATA=NEW3; VAR OMAPE1 OMAPE2 OMAPE3 OMAPE4;
RUN;
 
SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=NEW3;  
PLOT oy4_hat*t=1 oy*t=2 /* oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=2 */ 
/OVERLAY legend GRID FRAME 
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10;  
RUN;

PROC GPLOT DATA=NEW3;  
PLOT oy3_hat*t=1 oy*t=2 /* oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=2 */  
/OVERLAY legend GRID FRAME
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=NEW3;  
PLOT oy4_hat*t=1 oy*t=2 /* oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=2 */ 
/OVERLAY legend GRID FRAME 
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10;  
RUN;

PROC GPLOT DATA=NEW3;  
PLOT oy3_hat*t=1 oy*t=2 /* oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=2 */  
/OVERLAY legend GRID FRAME
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=NEW3;  
PLOT oy2_hat*t=1 oy*t=2 /* oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=2 */ 
/OVERLAY legend GRID FRAME 
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10;  
RUN;

PROC GPLOT DATA=NEW3;  
PLOT oy1_hat*t=1 oy*t=2 /* oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=2 */  
/OVERLAY legend GRID FRAME
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10; 
RUN;


