DATA SALE;
INFILE 'G:\BOX-ANN\SALE.dat'; 
INPUT X @@;
date=intnx('month', '1dec44'd,_n_);
format date monyy.;
t=_N_;
LogX=log(X);

t+1;
MONTH=MONTH(DATE);
IF MONTH=1 THEN ID1=1; ELSE ID1=0;
IF MONTH=2 THEN ID2=1; ELSE ID2=0;
IF MONTH=3 THEN ID3=1; ELSE ID3=0;
IF MONTH=4 THEN ID4=1; ELSE ID4=0;
IF MONTH=5 THEN ID5=1; ELSE ID5=0;
IF MONTH=6 THEN ID6=1; ELSE ID6=0;
IF MONTH=7 THEN ID7=1; ELSE ID7=0;
IF MONTH=8 THEN ID8=1; ELSE ID8=0;
IF MONTH=9 THEN ID9=1; ELSE ID9=0;
IF MONTH=10 THEN ID10=1; ELSE ID10=0;
IF MONTH=11 THEN ID11=1; ELSE ID11=0;
IF MONTH=12 THEN ID12=1; ELSE ID12=0;

LNXT=0.002723+8.7676*ID1+8.6933*ID2+8.7222*ID3+8.8589*ID4+8.8170*ID5
             +8.9463*ID6+9.1037*ID7+9.1338*ID8+8.8585*ID9+8.8436*ID10
             +8.6881*ID11+8.8016*ID12; 

/*
PROC PRINT; VAR t ID1 ID2 ID3 ID4 ID5 ID6 ID7 ID8 ID9 ID10 ID11 ID12 LNXT;
RUN; */

DATA DATA1;
SET SALE;
t+1;
MONTH=MONTH(DATE);
IF MONTH=1 THEN i1=1; ELSE i1=0;
IF MONTH=2 THEN i2=1; ELSE i2=0;
IF MONTH=3 THEN i3=1; ELSE i3=0;
IF MONTH=4 THEN i4=1; ELSE i4=0;
IF MONTH=5 THEN i5=1; ELSE i5=0;
IF MONTH=6 THEN i6=1; ELSE i6=0;
IF MONTH=7 THEN i7=1; ELSE i7=0;
IF MONTH=8 THEN i8=1; ELSE i8=0;
IF MONTH=9 THEN i9=1; ELSE i9=0;
IF MONTH=10 THEN i10=1; ELSE i10=0;
IF MONTH=11 THEN i11=1; ELSE i11=0;
IF MONTH=12 THEN i12=1; ELSE i12=0;
RUN;

PROC AUTOREG DATA=DATA1;
MODEL LogX=t i1-i12/noint nlag=13 backstep dwprob;
OUTPUT OUT=OUT1 RESID=RESID1;
RUN;

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=spline ci=black; 
SYMBOL6 v=star cv=black i=line ci=black; 
 
PROC GPLOT DATA=OUT1;
PLOT X*DATE=1 / VREF=0 grid frame; /* vaxis=-0.2 to 0.2 by 0.05;*/
RUN;

PROC GPLOT DATA=OUT1;
PLOT LogX*DATE=1 / VREF=0 grid frame; /* vaxis=-0.2 to 0.2 by 0.05;*/
RUN;

PROC GPLOT DATA=OUT1;
PLOT RESID1*DATE=3 / VREF=0 grid frame vaxis=-0.2 to 0.2 by 0.05;
RUN;





