DATA SALEAUTOREG;
INFILE 'G:\BOX-ANN\SALE.dat';   
INPUT SALE @@;
DATE=INTNX('MONTH', '1jan62'd,_n_);    /* '1dec83'd,_n_) */
FORMAT DATE MONYY.;
RUN;

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=SALEAUTOREG; 
PLOT SALE*DATE=1 /OVERLAY legend GRID FRAME 
VAXIS=5000 TO 16000 BY 1000; 
RUN; 

DATA SALEAUTOREG1; 
SET SALEAUTOREG;
TRSALE=LOG(SALE);
RUN;

PROC GPLOT DATA=SALEAUTOREG1; 
PLOT TRSALE*DATE=1 /OVERLAY legend GRID FRAME; 
RUN; 


DATA SALEAUTOREG2;
SET SALEAUTOREG1;         
t+1;
MONTH=MONTH(DATE);
IF MONTH=1 THEN IDt1=1; ELSE IDt1=0;
IF MONTH=2 THEN IDt2=1; ELSE IDt2=0;
IF MONTH=3 THEN IDt3=1; ELSE IDt3=0;
IF MONTH=4 THEN IDt4=1; ELSE IDt4=0;
IF MONTH=5 THEN IDt5=1; ELSE IDt5=0;
IF MONTH=6 THEN IDt6=1; ELSE IDt6=0;
IF MONTH=7 THEN IDt7=1; ELSE IDt7=0;
IF MONTH=8 THEN IDt8=1; ELSE IDt8=0;
IF MONTH=9 THEN IDt9=1; ELSE IDt9=0;
IF MONTH=10 THEN IDt10=1; ELSE IDt10=0; 
IF MONTH=11 THEN IDt11=1; ELSE IDt11=0; 
IF MONTH=12 THEN IDt12=1; ELSE IDt12=0;
RUN;

PROC AUTOREG DATA=SALEAUTOREG2;
MODEL TRSALE=t IDt1-IDt12/ NOINT METHOD=ML DWPROB;
OUTPUT OUT=OUT RESID=RESID;
RUN;

PROC GPLOT DATA=OUT;
PLOT RESID*DATE=3/OVERLAY legend GRID FRAME VREF=0 
VAXIS=-0.18 TO 0.18 BY 0.02; 
RUN;

PROC AUTOREG DATA=SALEAUTOREG2;
MODEL TRSALE=t IDt1-IDt12/ NOINT NLAG=13 BACKSTEP DWPROB;
OUTPUT OUT=OUT1 RESID=RESID1;
RUN;

PROC GPLOT DATA=OUT1;
PLOT RESID1*DATE=3/legend GRID FRAME VREF=0
VAXIS=-0.18 TO 0.18 BY 0.02;  
RUN;


/*
PROC GPLOT DATA=SALEAUTOREG; 
PLOT SALE*DATE=1;
RUN; 
VAXIS=5000 TO 16000 BY 1000; 

*/

/* HAXIS=0 TO 180 BY 10; HREF=1JAN52 */ 
