DATA DATA1;                        
INFILE 'G:\BOX-ANN\SUN331C.dat';   
INPUT x x1 x2 x3@@;
t=_N_;

/* proc means; var x x1 x2 x3; run; */

x=(x-0)/(200-0);  /* normalization of data */  
x1=(x1-0)/(200-0);
x2=(x2-0)/(200-0);
x3=(x3-0)/(200-0);

y=x;                   /* target  */  

eta=5.31;   
k=1;        
/* UNIFORM RANDOM NUMBERS for weights and biases */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_31=-UNIFORM(3+k)/10; ELSE w1_31=UNIFORM(3+k)/10;

IF UNIFORM(4+k)<=0.5 THEN w1_12=-UNIFORM(4+k)/10; ELSE w1_12=UNIFORM(4+k)/10;
IF UNIFORM(5+k)<=0.5 THEN w1_22=-UNIFORM(5+k)/10; ELSE w1_22=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN w1_32=-UNIFORM(6+k)/10; ELSE w1_32=UNIFORM(6+k)/10;

IF UNIFORM(7+k)<=0.5 THEN w1_13=-UNIFORM(7+k)/10; ELSE w1_13=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w1_23=-UNIFORM(8+k)/10; ELSE w1_23=UNIFORM(8+k)/10;
IF UNIFORM(9+k)<=0.5 THEN w1_33=-UNIFORM(9+k)/10; ELSE w1_33=UNIFORM(9+k)/10;

IF UNIFORM(17+k)<=0.5 THEN w1_14=-UNIFORM(17+k)/10; ELSE w1_14=UNIFORM(17+k)/10;
IF UNIFORM(18+k)<=0.5 THEN w1_24=-UNIFORM(18+k)/10; ELSE w1_24=UNIFORM(18+k)/10;
IF UNIFORM(19+k)<=0.5 THEN w1_34=-UNIFORM(19+k)/10; ELSE w1_34=UNIFORM(19+k)/10;

IF UNIFORM(10+k)<=0.5 THEN b1=-UNIFORM(10+k)/10; ELSE b1=UNIFORM(10+k)/10;
IF UNIFORM(11+k)<=0.5 THEN b2=-UNIFORM(11+k)/10; ELSE b2=UNIFORM(11+k)/10;
IF UNIFORM(12+k)<=0.5 THEN b3=-UNIFORM(12+k)/10; ELSE b3=UNIFORM(12+k)/10;
IF UNIFORM(20+k)<=0.5 THEN b4=-UNIFORM(20+k)/10; ELSE b4=UNIFORM(20+k)/10;

IF UNIFORM(13+k)<=0.5 THEN w2_11=-UNIFORM(13+k)/10; ELSE w2_11=UNIFORM(13+k)/10;
IF UNIFORM(14+k)<=0.5 THEN w2_21=-UNIFORM(14+k)/10; ELSE w2_21=UNIFORM(14+k)/10;
IF UNIFORM(15+k)<=0.5 THEN w2_31=-UNIFORM(15+k)/10; ELSE w2_31=UNIFORM(15+k)/10;
IF UNIFORM(21+k)<=0.5 THEN w2_41=-UNIFORM(21+k)/10; ELSE w2_41=UNIFORM(21+k)/10;

IF UNIFORM(16+k)<=0.5 THEN b5=-UNIFORM(16+k)/10; ELSE b5=UNIFORM(16+k)/10;

/* first linear transformation */
z1=w1_11*x1+w1_21*x2+w1_31*x3;                
z2=w1_12*x1+w1_22*x2+w1_32*x3;    
z3=w1_13*x1+w1_23*x2+w1_33*x3;   
z4=w1_14*x1+w1_24*x2+w1_34*x3;   

/* first activity function */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));
s3=1/(1+exp(-(z3+b3))); 
s4=1/(1+exp(-(z4+b4))); 

z5=w2_11*s1+w2_21*s2+w2_31*s3+w2_41*s4;

s5=1/(1+exp(-(z5+b5)));
 
y1_hat=s5;                  /* This is the 1st estimate.*/

              x=1; 
              DO WHILE(x<=1);  

/* 1ST BACKPROPAGATION step 1(right hand size) */
pLpw2_11=-2*(y-y1_hat)*s5*(1-s5)*s1;   
pLpw2_21=-2*(y-y1_hat)*s5*(1-s5)*s2;
pLpw2_31=-2*(y-y1_hat)*s5*(1-s5)*s3;
pLpw2_41=-2*(y-y1_hat)*s5*(1-s5)*s4;

pLpb5=-2*(y-y1_hat)*s5*(1-s5);

/* new wights ws_11 etc p13 */
w2_11=w2_11-eta*pLpw2_11; 
w2_21=w2_21-eta*pLpw2_21; 
w2_31=w2_31-eta*pLpw2_31; 
w2_41=w2_41-eta*pLpw2_41; 

b5=b5-eta*pLpb5; 

/* 2. BACKPROPAGATION step 2(left hand side)  */
pLpw1_11=-2*(y-y1_hat)*s5*(1-s5)*w2_11*s1*(1-s1)*x1; 
pLpw1_21=-2*(y-y1_hat)*s5*(1-s5)*w2_11*s1*(1-s1)*x2;  
pLpw1_31=-2*(y-y1_hat)*s5*(1-s5)*w2_11*s1*(1-s1)*x3;  

pLpw1_12=-2*(y-y1_hat)*s5*(1-s5)*w2_21*s2*(1-s2)*x1; 
pLpw1_22=-2*(y-y1_hat)*s5*(1-s5)*w2_21*s2*(1-s2)*x2;  
pLpw1_32=-2*(y-y1_hat)*s5*(1-s5)*w2_21*s2*(1-s2)*x3;  

pLpw1_13=-2*(y-y1_hat)*s5*(1-s5)*w2_31*s3*(1-s3)*x1; 
pLpw1_23=-2*(y-y1_hat)*s5*(1-s5)*w2_31*s3*(1-s3)*x2;  
pLpw1_33=-2*(y-y1_hat)*s5*(1-s5)*w2_31*s3*(1-s3)*x3;  

pLpw1_14=-2*(y-y1_hat)*s5*(1-s5)*w2_41*s4*(1-s4)*x1; 
pLpw1_24=-2*(y-y1_hat)*s5*(1-s5)*w2_41*s4*(1-s4)*x2;  
pLpw1_34=-2*(y-y1_hat)*s5*(1-s5)*w2_41*s4*(1-s4)*x3;  

pLpb1=-2*(y-y1_hat)*s5*(1-s5)*w2_11*s1*(1-s1);  
pLpb2=-2*(y-y1_hat)*s5*(1-s5)*w2_21*s2*(1-s2);  
pLpb3=-2*(y-y1_hat)*s5*(1-s5)*w2_31*s3*(1-s3);  
pLpb4=-2*(y-y1_hat)*s5*(1-s5)*w2_41*s4*(1-s4);  

/* SECOND STEP UPDATED WEIGHTS */
w1_11=w1_11-eta*pLpw1_11; 
w1_21=w1_21-eta*pLpw1_21;
w1_31=w1_31-eta*pLpw1_31;
w1_12=w1_12-eta*pLpw1_12; 
w1_22=w1_22-eta*pLpw1_22;
w1_32=w1_32-eta*pLpw1_32;
w1_13=w1_13-eta*pLpw1_13; 
w1_23=w1_23-eta*pLpw1_23;
w1_33=w1_33-eta*pLpw1_33;
w1_14=w1_14-eta*pLpw1_14; 
w1_24=w1_24-eta*pLpw1_24;
w1_34=w1_34-eta*pLpw1_34;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                    
b2=b2-eta*pLpb2; 
b3=b3-eta*pLpb3; 
b4=b4-eta*pLpb4; 
b5=b5-eta*pLpb5; 

z1=w1_11*x1+w1_21*x2+w1_31*x3;                
z2=w1_12*x1+w1_22*x2+w1_32*x3;    
z3=w1_13*x1+w1_23*x2+w1_33*x3;   
z4=w1_14*x1+w1_24*x2+w1_34*x3;   
                                   
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));
s3=1/(1+exp(-(z3+b3))); 
s4=1/(1+exp(-(z4+b4))); 

z5=w2_11*s1+w2_21*s2+w2_31*s3+w2_41*s4;

s5=1/(1+exp(-(z5+b5)));
 
y2_hat=s5;                  /* This is the 2nd estimate.*/

Rx=x*(200-0)+0;
Rx1=x1*(200-0)+0;
Rx2=x2*(200-0)+0;
Rx3=x3*(200-0)+0;

Ry=y*(200-0)+0;

Ry1_hat=y1_hat*(200-0)+0;
Ry2_hat=y2_hat*(200-0)+0; 
 
MSE1=(y-y1_hat)**2;                     
MSE2=(y-y2_hat)**2;
RMSE1=(Ry-Ry1_hat)**2;                     
RMSE2=(Ry-Ry2_hat)**2;

MAE1=ABS(y-y1_hat); 
MAE2=ABS(y-y2_hat);
RMAE1=ABS(Ry-Ry1_hat); 
RMAE2=ABS(Ry-Ry2_hat);

MASE_aa2=ABS(y-lag4(y));
RMASE_aa2=ABS(Ry-lag11(Ry));

MASE1=MAE1/0.2829888;             
MASE2=MAE2/56.5977528;             
RMASE1=RMAE1/0.2829888;             
RMASE2=RMAE2/56.5977528;

RMSE1=SQRT(MSE1); 
RMSE2=SQRT(MSE2);
RRMSE1=SQRT(RMSE1); 
RRMSE2=SQRT(RMSE2);

IF y=0 THEN y=0.001;
MPE1=((y-y1_hat)/y)*100;
MPE2=((y-y2_hat)/y)*100; 
RMPE1=((Ry-Ry1_hat)/y)*100;
RMPE2=((Ry-Ry2_hat)/y)*100; 

MAPE1=(ABS(y-y1_hat)/y)*100; 
MAPE2=(ABS(y-y2_hat)/y)*100; 
RMAPE1=(ABS(Ry-Ry1_hat)/y)*100; 
RMAPE2=(ABS(Ry-Ry2_hat)/y)*100; 

             OUTPUT;
             x+1;
             END; 
             RUN;  

proc print; var w1_11 x1 z1 s1 w1_11 w1_34 pLpw1_11;
run;
proc print; var y y1_hat y2_hat Ry Ry1_hat Ry2_hat;
run; 

PROC MEANS;	VAR MASE_aa2 RMASE_aa2;
RUN; 

PROC MEANS; VAR MSE1 MSE2 RMSE1 RMSE2;
RUN;

PROC MEANS; VAR MASE1 MASE2 RMASE1 RMASE2;
RUN;

PROC MEANS; VAR MAE1 MAE2 RMAE1 RMAE2;
RUN;

PROC MEANS; VAR MAPE1 MAPE2 RMAPE1 RMAPE2;
RUN;

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=DATA1;   
PLOT y*t=4 y2_hat*t=3/OVERLAY legend GRID FRAME HREF=446.5 
HAXIS=0 TO 500 BY 50;  
RUN; 

PROC GPLOT DATA=DATA1;   
PLOT y2_hat*t=3/OVERLAY legend GRID FRAME HREF=446.5 
HAXIS=0 TO 500 BY 50;  
RUN; 

PROC GPLOT DATA=DATA1;   
PLOT Ry*t=4/OVERLAY legend GRID FRAME HREF=446.5 
HAXIS=0 TO 500 BY 50;  
RUN; 

PROC GPLOT DATA=DATA1;   
PLOT Ry*t=4 Ry2_hat*t=3 /* Fore*t=2 */ /OVERLAY legend GRID FRAME HREF=446.5 
HAXIS=0 TO 500 BY 50;  
RUN; 



