DATA invento;
INFILE 'G:\BOX-ANN\INVENTO.dat';    
t=_N_;
INPUT xt @@;
xt1=DIF1(xt);

PROC PRINT DATA=INVENTO; 
RUN; 

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=spline ci=black;

PROC MEANS DATA=INVENTO; 
RUN;

PROC GPLOT;
PLOT xt*t=1/VREF=6.095 OVERLAY grid frame 
vaxis=-20 to 30 by 5 haxis=0 to 60 by 5;
RUN;

PROC GPLOT DATA=INVENTO;
PLOT xt1*t=1/VREF=0.030 OVERLAY grid frame 
vaxis=-20 to 30 by 5 haxis=0 to 60 by 5;
RUN;

PROC ARIMA;
IDENTIFY VAR=xt NLAG=20;
RUN;



/*  HREF=52.5 HMINOR=0 VMINOR=0  */