DATA employdata;
INFILE 'G:\BOX-ANN\EMPLOY.dat';
INPUT X @@;
t=_N_;
X1=DIF1(X);
X12=DIF12(X1);
 
PROC PRINT; VAR t X X1 X12;
RUN;
 
SYMBOL1 v=dot cv=black i=spline ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=employdata;
PLOT X*t=1/OVERLAY GRID VREF=826.4697 FRAME VAXIS=200 TO 1600 BY 200 HAXIS=0 TO 130 BY 6;
RUN;

PROC REG DATA=employdata;
MODEL X=t;
OUTPUT OUT=first P=PREDICT R=RESID;
RUN;

PROC GPLOT DATA=first;
PLOT X*t PREDICT*t/OVERLAY GRID VREF=826.4697 FRAME VAXIS=200 TO 1600 BY 200 HAXIS=0 TO 130 BY 6;
RUN;

PROC ARIMA DATA=employdata;
IDENTIFY VAR=X NLAG=36;    
RUN;

