DATA analy;
INFILE 'G:\BOX-ANN\EXPORTS.dat';
INPUT q exports @@;
t=_N_;
DATE=INTNX('quarter','1jan58'd,_N_-1); 
format date yyq5.;

exportsm=exports-1141.87;
DIFF1=dif1(exports);
DIFF4=dif4(exports);
DIFF1M=DIFF1-20.0268293;
DIFF4M=DIFF4;/*-75.4263; -3.8889842;*/

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i= spline ci=black;

PROC ARIMA;
IDENTIFY VAR=DIFF1 NLAG=36;
RUN;

DATA SASd2;
INPUT Lag SACOVAF SACF SE;
twoSE=1.96*SE;
ntwoSE=(-1)*twoSE;

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 

LINES;
                    0     17052.420        1.00000            0
                    1    -10730.766        -.62928     0.156174
                    2      7126.614        0.41792     0.209062
                    3     -8343.519        -.48929     0.228532
                    4      7034.380        0.41252     0.252795
                    5     -5265.299        -.30877     0.268712
                    6      3327.503        0.19513     0.277231
                    7     -4772.302        -.27986     0.280561
                    8      6952.070        0.40769     0.287289
                    9     -7037.570        -.41270     0.301069
                   10      6842.381        0.40126     0.314565
                   11     -7328.940        -.42979     0.326810
                   12      8277.253        0.48540     0.340317
                   13     -7882.951        -.46228     0.356804
                   14      4818.810        0.28259     0.371125
                   15     -2913.698        -.17087     0.376336
                   16      4151.802        0.24347     0.378224
                   17     -3744.309        -.21958     0.382027
                   18      1371.254        0.08041     0.385093
                   19     -1939.736        -.11375     0.385502
                   20      2873.910        0.16853     0.386320
                   21     -3417.659        -.20042     0.388109
                   22      3201.120        0.18772     0.390625
                   23     -3075.353        -.18035     0.392820
                   24      4781.263        0.28039     0.394834
                   25     -4369.741        -.25625     0.399661
                   26      2786.944        0.16343     0.403648
                   27     -2491.981        -.14614     0.405259
                   28      1575.334        0.09238     0.406542
                   29     -1240.343        -.07274     0.407054
                   30       578.524        0.03393     0.407371
                   31      -583.068        -.03419     0.407440
                   32      1140.120        0.06686     0.407510
                   33      -842.980        -.04943     0.407777
                   34      1419.437        0.08324     0.407923
                   35     -1165.092        -.06832     0.408337
                   36      1362.131        0.07988     0.408616
; 
PROC PRINT;
RUN;
PROC GPLOT DATA=SASd2;
PLOT SACF*Lag=1 twoSE*Lag=4 ntwoSE*Lag=4/VREF=0  
         OVERLAY grid frame vaxis=-1.0 to 1.0 by 0.2 haxis=0 to 36 by 2;
RUN;

DATA SASd3;
INPUT Lag PSACF SE;
twoSE=1.96*SE;
ntwoSE=(-1)*twoSE;

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 

LINES;
                                  1       -0.62928    0.156174
                                  2        0.03631    0.156174
                                  3       -0.35311    0.156174
                                  4       -0.04889    0.156174
                                  5       -0.03627    0.156174
                                  6       -0.18019    0.156174
                                  7       -0.27518    0.156174
                                  8        0.18785    0.156174
                                  9       -0.23153    0.156174
                                 10        0.02829    0.156174
                                 11       -0.06873    0.156174
                                 12        0.06499    0.156174
                                 13       -0.09328    0.156174
                                 14       -0.19859    0.156174
                                 15        0.13771    0.156174
                                 16        0.03958    0.156174
                                 17        0.00709    0.156174
                                 18       -0.13344    0.156174
                                 19       -0.01905    0.156174
                                 20       -0.18185    0.156174
                                 21       -0.04526    0.156174
                                 22       -0.04416    0.156174
                                 23       -0.12940    0.156174
                                 24        0.09769    0.156174
                                 25       -0.03490    0.156174
                                 26       -0.03720    0.156174
                                 27       -0.09688    0.156174
                                 28       -0.10213    0.156174
                                 29       -0.03305    0.156174
                                 30       -0.07656    0.156174
                                 31       -0.18947    0.156174
                                 32       -0.14346    0.156174
                                 33        0.01352    0.156174
                                 34       -0.10999    0.156174
                                 35        0.06123    0.156174
                                 36       -0.04704    0.156174
; 
PROC PRINT;
RUN;
PROC GPLOT DATA=SASd3;
PLOT PSACF*Lag=1 twoSE*Lag=4 ntwoSE*Lag=4/VREF=0  
         OVERLAY grid frame vaxis=-1.0 to 1.0 by 0.2 haxis=1 to 36 by 2;
RUN;
