DATA DATA0;     
INFILE 'G:\BOX-ANN\CHILD.dat'; 
INPUT k y1 x11 x12 @@;  
t=_N_; 
y=(y1-90)/(120-90); x1=(x11-1)/(6-1); x2=(x12-20)/(30-20);
                              /* x1=0.8; x2=0.9; x11=5; x12=29 */
eta=0.05;               
                        
h=1;                    /* change the seed of random numbers */                     
/* UNIFORM RANDOM NUMBERS for weights and biases */
IF UNIFORM(1+h)<=0.5 THEN w1_11=-UNIFORM(1+h)/10; ELSE w1_11=UNIFORM(1+h)/10;
IF UNIFORM(2+h)<=0.5 THEN w1_21=-UNIFORM(2+h)/10; ELSE w1_21=UNIFORM(2+h)/10;
IF UNIFORM(3+h)<=0.5 THEN w1_12=-UNIFORM(3+h)/10; ELSE w1_12=UNIFORM(3+h)/10;
IF UNIFORM(4+h)<=0.5 THEN w1_22=-UNIFORM(4+h)/10; ELSE w1_22=UNIFORM(4+h)/10;
IF UNIFORM(5+h)<=0.5 THEN w1_13=-UNIFORM(5+h)/10; ELSE w1_13=UNIFORM(5+h)/10;
IF UNIFORM(6+h)<=0.5 THEN w1_23=-UNIFORM(6+h)/10; ELSE w1_23=UNIFORM(6+h)/10;
IF UNIFORM(7+h)<=0.5 THEN w1_14=-UNIFORM(7+h)/10; ELSE w1_14=UNIFORM(7+h)/10;
IF UNIFORM(8+h)<=0.5 THEN w1_24=-UNIFORM(8+h)/10; ELSE w1_24=UNIFORM(8+h)/10;
IF UNIFORM(9+h)<=0.5 THEN b1=-UNIFORM(9+h)/10; ELSE b1=UNIFORM(9+h)/10;
IF UNIFORM(10+h)<=0.5 THEN b2=-UNIFORM(10+h)/10; ELSE b2=UNIFORM(10+h)/10;
IF UNIFORM(11+h)<=0.5 THEN b3=-UNIFORM(11+h)/10; ELSE b3=UNIFORM(11+h)/10;
IF UNIFORM(12+h)<=0.5 THEN b4=-UNIFORM(12+h)/10; ELSE b4=UNIFORM(12+h)/10;
IF UNIFORM(13+h)<=0.5 THEN b5=-UNIFORM(13+h)/10; ELSE b5=UNIFORM(13+h)/10; 
IF UNIFORM(14+h)<=0.5 THEN w2_11=-UNIFORM(14+h)/10; ELSE w2_11=UNIFORM(14+h)/10;
IF UNIFORM(15+h)<=0.5 THEN w2_21=-UNIFORM(15+h)/10; ELSE w2_21=UNIFORM(15+h)/10;
IF UNIFORM(16+h)<=0.5 THEN w2_31=-UNIFORM(16+h)/10; ELSE w2_31=UNIFORM(16+h)/10;
IF UNIFORM(17+h)<=0.5 THEN w2_41=-UNIFORM(17+h)/10; ELSE w2_41=UNIFORM(17+h)/10;
IF UNIFORM(18+h)<=0.5 THEN b6=-UNIFORM(18+h)/10; ELSE b6=UNIFORM(18+h)/10; 
IF UNIFORM(19+h)<=0.5 THEN b7=-UNIFORM(19+h)/10; ELSE b7=UNIFORM(19+h)/10;
IF UNIFORM(20+h)<=0.5 THEN b8=-UNIFORM(20+h)/10; ELSE b8=UNIFORM(20+h)/10;
IF UNIFORM(21+h)<=0.5 THEN b9=-UNIFORM(21+h)/10; ELSE b9=UNIFORM(21+h)/10;
IF UNIFORM(22+h)<=0.5 THEN b10=-UNIFORM(22+h)/10; ELSE b10=UNIFORM(22+h)/10; 
IF UNIFORM(23+h)<=0.5 THEN b11=-UNIFORM(23+h)/10; ELSE b11=UNIFORM(23+h)/10;
IF UNIFORM(24+h)<=0.5 THEN b12=-UNIFORM(24+h)/10; ELSE b12=UNIFORM(24+h)/10;
IF UNIFORM(25+h)<=0.5 THEN b13=-UNIFORM(25+h)/10; ELSE b13=UNIFORM(25+h)/10;
IF UNIFORM(26+h)<=0.5 THEN b14=-UNIFORM(26+h)/10; ELSE b14=UNIFORM(26+h)/10; 
IF UNIFORM(27+h)<=0.5 THEN b15=-UNIFORM(27+h)/10; ELSE b15=UNIFORM(27+h)/10; 

/* FIRST LINEAR TRANSFORMATION */
z1=w1_11*x1+w1_21*x2; z2=w1_12*x1+w1_22*x2;   
z3=w1_13*x1+w1_23*x2; z4=w1_14*x1+w1_24*x2;   

/* FIRST ACTIVITY FUNCTION */
h=2;
IF UNIFORM(24+h)<=0.5 THEN b16=-UNIFORM(24+h)/10; ELSE b16=UNIFORM(24+h)/10;
IF UNIFORM(25+h)<=0.5 THEN b17=-UNIFORM(25+h)/10; ELSE b17=UNIFORM(25+h)/10;
IF UNIFORM(26+h)<=0.5 THEN b18=-UNIFORM(26+h)/10; ELSE b18=UNIFORM(26+h)/10; 
IF UNIFORM(27+h)<=0.5 THEN b19=-UNIFORM(27+h)/10; ELSE b19=UNIFORM(27+h)/10; 

s1=1/(1+exp(-z1+b16)); s2=1/(1+exp(-z2+b17));
s3=1/(1+exp(-z3+b18)); s4=1/(1+exp(-z4+b19));                                          

/* SECOND LINEAR TRANSFORMATION */ 
z5=w2_11*s1+w2_21*s2+w2_31*s3+w2_41*s4;

/* FIRST ESTIMATED VALUE */ 
s5=1/(1+exp(-(z5+b5)));
y_hat=s5; 

/* ORIGINAL UNIT FOR y_hat=s5; */
By_hat=y_hat*(120-90)+90;

/* PARTIAL DERIVATIVES OF LOSS FUNCTION w/t WEIGHT */
pLpw1_11=-2*(y-y_hat)*(w2_11*s5*(1-s5))*(x1*s1*(1-s1));
pLpw1_21=-2*(y-y_hat)*(w2_21*s5*(1-s5))*(x2*s1*(1-s1));
pLpw1_12=-2*(y-y_hat)*(w2_31*s5*(1-s5))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y_hat)*(w2_41*s5*(1-s5))*(x2*s2*(1-s2));
pLpw1_13=-2*(y-y_hat)*(w2_11*s5*(1-s5))*(x1*s3*(1-s3));
pLpw1_23=-2*(y-y_hat)*(w2_21*s5*(1-s5))*(x2*s3*(1-s3));
pLpw1_14=-2*(y-y_hat)*(w2_31*s5*(1-s5))*(x1*s4*(1-s4));
pLpw1_24=-2*(y-y_hat)*(w2_41*s5*(1-s5))*(x2*s4*(1-s4));

pLpb1=-2*(y-y_hat)*(w2_11*s5*(1-s5))*(1*s1*(1-s1));
pLpb2=-2*(y-y_hat)*(w2_21*s5*(1-s5))*(1*s2*(1-s2));
pLpb3=-2*(y-y_hat)*(w2_31*s5*(1-s5))*(1*s3*(1-s3));
pLpb4=-2*(y-y_hat)*(w2_41*s5*(1-s5))*(1*s4*(1-s4));

/*  BACKPROPAGATION step 1(right hand size) */
pLpw2_11=-2*(y-y_hat)*s5*(1-s5)*s1;
pLpw2_21=-2*(y-y_hat)*s5*(1-s5)*s2;
pLpw2_31=-2*(y-y_hat)*s5*(1-s5)*s3;
pLpw2_41=-2*(y-y_hat)*s5*(1-s5)*s4;

pLpb5=-2*(y-y_hat)*s5*(1-s5)*1; 

/* new wights ws_11 etc p13 */
w2s_11=w2_11-eta*pLpw2_11;
w2s_21=w2_21-eta*pLpw2_21; 
w2s_31=w2_31-eta*pLpw2_31;
w2s_41=w2_41-eta*pLpw2_41;

b5s=b5-eta*pLpb5;

/* FIRST STEP UPDATED WEIGHTS */
pLpw2s_11=pLpw2_11-eta*pLpw2_11; 
pLpw2s_21=pLpw2_21-eta*pLpw2_21;
pLpw2s_31=pLpw2_31-eta*pLpw2_31; 
pLpw2s_41=pLpw2_41-eta*pLpw2_41;

/* BACKPROPAGATION step 2(left hand size) pp.14-15 */
pLpw1s_11=-2*(y-y_hat)*(w2_11*s5*(1-s5))*(x1*s1*(1-s1));
pLpw1s_21=-2*(y-y_hat)*(w2_21*s5*(1-s5))*(x2*s1*(1-s1));
pLpw1s_12=-2*(y-y_hat)*(w2_31*s5*(1-s5))*(x1*s2*(1-s2));
pLpw1s_22=-2*(y-y_hat)*(w2_41*s5*(1-s5))*(x2*s2*(1-s2));
pLpw1s_13=-2*(y-y_hat)*(w2_11*s5*(1-s5))*(x1*s3*(1-s3));
pLpw1s_23=-2*(y-y_hat)*(w2_21*s5*(1-s5))*(x2*s3*(1-s3));
pLpw1s_14=-2*(y-y_hat)*(w2_31*s5*(1-s5))*(x1*s4*(1-s4));
pLpw1s_24=-2*(y-y_hat)*(w2_41*s5*(1-s5))*(x2*s4*(1-s4));

/* SECOND STEP UPDATED WEIGHTS p.15 */
w1s_11=w1_11-eta*pLpw1s_11; w1s_21=w1_21-eta*pLpw1s_21;
w1s_12=w1_12-eta*pLpw1s_12; w1s_22=w1_22-eta*pLpw1s_22;
w1s_13=w1_13-eta*pLpw1s_13; w1s_23=w1_23-eta*pLpw1s_23;
w1s_14=w1_14-eta*pLpw1s_14; w1s_24=w1_24-eta*pLpw1s_24;

b1s_1=b1-eta*pLpb1; b1s_2=b2-eta*pLpb2;
b1s_3=b3-eta*pLpb3; b1s_4=b4-eta*pLpb4;

/* CHECK step HERE p.16 */
zs_1=w1s_11*x1+w1s_21*x2;
zs_2=w1s_12*x1+w1s_22*x2;
zs_3=w1s_13*x1+w1s_23*x2;
zs_4=w1s_14*x1+w1s_24*x2;

ss_1=1/(1+exp(-(zs_1+b11)));  
ss_2=1/(1+exp(-(zs_2+b12)));
ss_3=1/(1+exp(-(zs_3+b13)));
ss_4=1/(1+exp(-(zs_4+b14)));

zs_5=w2s_11*ss_1+w2s_21*ss_2+w2s_31*ss_3+w2s_41*ss_4;

ss5=1/(1+exp(-(zs_5+b15)));  
y1_hat=ss5;    

By1_hat=y1_hat*(120-90)+90;

/* y89_hat at (x1,x2)=(0.8, 0.9); */
x10=0.8; x20=0.9; 
z10=w1_11*x10+w1_21*x20; z20=w1_12*x10+w1_22*x20;   
z30=w1_13*x10+w1_23*x20; z40=w1_14*x10+w1_24*x20;   

h=2;
IF UNIFORM(24+h)<=0.5 THEN b20=-UNIFORM(24+h)/10; ELSE b20=UNIFORM(24+h)/10;
IF UNIFORM(25+h)<=0.5 THEN b21=-UNIFORM(25+h)/10; ELSE b21=UNIFORM(25+h)/10;
IF UNIFORM(26+h)<=0.5 THEN b22=-UNIFORM(26+h)/10; ELSE b22=UNIFORM(26+h)/10; 
IF UNIFORM(27+h)<=0.5 THEN b23=-UNIFORM(27+h)/10; ELSE b23=UNIFORM(27+h)/10; 
IF UNIFORM(28+h)<=0.5 THEN b24=-UNIFORM(28+h)/10; ELSE b24=UNIFORM(28+h)/10; 

s10=1/(1+exp(-z10+b20)); s20=1/(1+exp(-z20+b21));
s30=1/(1+exp(-z30+b22)); s40=1/(1+exp(-z40+b23));                                          

z89=w2_11*s10+w2_21*s20+w2_31*s30+w2_41*s40;
s89=1/(1+exp(-(z89+b24)));
y89_hat=s89; 
By89_hat=y89_hat*(120-90)+90; 

/* y0_hat at (x1,x2)=(3, 27); */
x110=3; x120=27;
z110=w1_11*x110+w1_21*x120; z120=w1_12*x110+w1_22*x120;   
z130=w1_13*x110+w1_23*x120; z140=w1_14*x110+w1_24*x120;   

h=3;
IF UNIFORM(29+h)<=0.5 THEN b25=-UNIFORM(29+h)/10; ELSE b25=UNIFORM(29+h)/10;
IF UNIFORM(30+h)<=0.5 THEN b26=-UNIFORM(30+h)/10; ELSE b26=UNIFORM(30+h)/10;
IF UNIFORM(31+h)<=0.5 THEN b27=-UNIFORM(31+h)/10; ELSE b27=UNIFORM(31+h)/10; 
IF UNIFORM(32+h)<=0.5 THEN b28=-UNIFORM(32+h)/10; ELSE b28=UNIFORM(32+h)/10; 
IF UNIFORM(33+h)<=0.5 THEN b29=-UNIFORM(33+h)/10; ELSE b29=UNIFORM(33+h)/10; 

s110=1/(1+exp(-z110+b25)); s120=1/(1+exp(-z120+b26));
s130=1/(1+exp(-z130+b27)); s140=1/(1+exp(-z140+b28));                                          

z37=w2_11*s110+w2_21*s120+w2_31*s130+w2_41*s140;
s37=1/(1+exp(-(z37+b29)));
y37_hat=s37; 
By37_hat=y37_hat*(120-90)+90; 

/* updated estimate y*_hat */
zs_11=w1s_11*x1+w1s_21*x2;
zs_22=w1s_12*x1+w1s_22*x2;
zs_33=w1s_13*x1+w1s_23*x2;
zs_44=w1s_14*x1+w1s_24*x2;

h=3;
IF UNIFORM(34+h)<=0.5 THEN b30=-UNIFORM(34+h)/10; ELSE b30=UNIFORM(34+h)/10;
IF UNIFORM(35+h)<=0.5 THEN b31=-UNIFORM(35+h)/10; ELSE b31=UNIFORM(35+h)/10;
IF UNIFORM(36+h)<=0.5 THEN b32=-UNIFORM(36+h)/10; ELSE b32=UNIFORM(36+h)/10; 
IF UNIFORM(37+h)<=0.5 THEN b33=-UNIFORM(37+h)/10; ELSE b33=UNIFORM(37+h)/10; 
IF UNIFORM(38+h)<=0.5 THEN b34=-UNIFORM(38+h)/10; ELSE b34=UNIFORM(38+h)/10; 

ss_11=1/(1+exp(-(zs_11+b30)));
ss_22=1/(1+exp(-(zs_22+b31)));
ss_33=1/(1+exp(-(zs_33+b32)));
ss_44=1/(1+exp(-(zs_44+b33)));

zs_55=w2s_11*ss_11+w2s_11*ss_22+w2s_11*ss_33+w2s_11*ss_44;
ys_55=1/(1+exp(-(zs_55+b34)));
Bys_55=ys_55*(120-90)+90; 

/*  NEW ERROR */
ERROR=y-y_hat;
BERROR=(y-y_hat)*(120-90)+90;
ERROR_sq=(y-y_hat)**2;
BERROR_sq=ERROR_sq*(120-90)+90;

ERROR1=y-y1_hat;
BERROR1=(y-y1_hat)*(120-90)+90;
ERROR1_sq=(y-y1_hat)**2;
BERROR1_sq=ERROR1_sq*(120-90)+90;

PROC PRINT; VAR z1 z2 z3 z4 s1 s2 s3 s4 z5 s5 y_hat By_hat; 
RUN;
PROC PRINT; VAR pLpw1_11 pLpw1_21 pLpw1_12 pLpw1_22 pLpw1_13 pLpw1_23 pLpw1_14 pLpw1_24; 
RUN;
PROC PRINT; VAR pLpb1 pLpb2 pLpb3 pLpb4; 
RUN;
PROC PRINT; VAR pLpw2_11 pLpw2_21 pLpw2_31 pLpw2_41 pLpb5; 
RUN;
PROC PRINT; VAR w2s_11 w2s_21 w2s_31 w2s_41 b5s; 
RUN;
PROC PRINT; VAR pLpw2s_11 pLpw2s_21 pLpw2s_31 pLpw2s_41; 
RUN;
PROC PRINT; VAR pLpw1s_11 pLpw1s_21 pLpw1s_12 pLpw1s_22 pLpw1s_13 pLpw1s_23 pLpw1s_14 pLpw1s_24; 
RUN;
PROC PRINT; VAR w1s_11 w1s_12 w1s_13 w1s_14; 
RUN;
PROC PRINT; VAR b1s_1 b1s_2 b1s_3 b1s_4;
RUN;
PROC PRINT; VAR zs_1 zs_2 zs_3 zs_4 ss_1 ss_2 ss_3 ss_4 zs_5 ss5 y1_hat By1_hat; 
RUN;
PROC PRINT; VAR ERROR BERROR ERROR_sq BERROR_sq ERROR1 BERROR1 ERROR1_sq BERROR1_sq; 
RUN;
PROC PRINT; VAR s10 s20 s30 s40 z89 s89 y89_hat By89_hat; 
RUN;
PROC PRINT; VAR s110 s120 s130 s140 z37 s37 y37_hat By37_hat; 
RUN;

PROC PRINT; VAR zs_11 zs_22 zs_33 zs_44 ss_11 ss_22 ss_33 ss_44 zs_55 ys_55 Bys_55; 
RUN;

SYMBOL1 v=dot cv=black l=1 color=red;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=none cv=black i=join ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=DATA0;  
PLOT BERROR_sq*x11=1/OVERLAY grid frame;  
RUN;

PROC GPLOT DATA=DATA0;  
PLOT ERROR*x11=1/OVERLAY grid frame;  
RUN;

PROC GPLOT DATA=DATA0;  
PLOT ERROR_sq*x11=1/OVERLAY grid frame;  
RUN;

PROC GPLOT DATA=DATA0;  
PLOT BERROR*x11=1/OVERLAY grid frame;  
RUN;

PROC REG DATA=DATA0;                /* orignal data by_hat */
MODEL y1=x11 x12/p clb vif alpha=0.05;
OUTPUT OUT=new PREDICTED=pred RESIDUAL=resid;
RUN;

PROC REG DATA=DATA0;                /* orignal data by_hat */
MODEL y=x1 x2/p clb vif alpha=0.05;
OUTPUT OUT=new1 PREDICTED=pred1 RESIDUAL=resid1;
RUN;


