DATA INCOMEDATA;
INFILE 'G:\FSAScodedata_2010\INCOMES0.dat';   /* INCOMES9>INCOMES0 */
INPUT x1 x2 x3 x4 x5@@;
t=_N_;

x1=(x1-1684.61)/(4191.43-1684.61);  /* normalization of data */  
x2=(x2-1684.61)/(4191.43-1684.61);
x3=(x3-1684.61)/(4191.43-1684.61);
x4=(x4-1684.61)/(4191.43-1684.61);
x5=(x5-1684.61)/(4191.43-1684.61);

/* x1=log(x1); x2=log(x2); x3=log(x3); x4=log(x4); x5=log(x5); not nece */

y=x5;     /* target value */

IF t>108 THEN DELETE; 

k=1;
eta=1.19; /* 1.19 1.0 eta=1.2; */
/* UNIFORM RANDOM NUMBERS for weights and biases */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_12=-UNIFORM(3+k)/10; ELSE w1_12=UNIFORM(3+k)/10;
IF UNIFORM(4+k)<=0.5 THEN w1_22=-UNIFORM(4+k)/10; ELSE w1_22=UNIFORM(4+k)/10;
IF UNIFORM(5+k)<=0.5 THEN w1_13=-UNIFORM(5+k)/10; ELSE w1_13=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN w1_23=-UNIFORM(6+k)/10; ELSE w1_23=UNIFORM(6+k)/10;
IF UNIFORM(7+k)<=0.5 THEN w1_14=-UNIFORM(7+k)/10; ELSE w1_14=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w1_24=-UNIFORM(8+k)/10; ELSE w1_24=UNIFORM(8+k)/10;
IF UNIFORM(9+k)<=0.5 THEN w1_15=-UNIFORM(9+k)/10; ELSE w1_15=UNIFORM(9+k)/10;
IF UNIFORM(10+k)<=0.5 THEN w1_25=-UNIFORM(10+k)/10; ELSE w1_25=UNIFORM(10+k)/10;
IF UNIFORM(11+k)<=0.5 THEN w1_16=-UNIFORM(11+k)/10; ELSE w1_16=UNIFORM(11+k)/10;
IF UNIFORM(12+k)<=0.5 THEN w1_26=-UNIFORM(12+k)/10; ELSE w1_26=UNIFORM(12+k)/10;
IF UNIFORM(13+k)<=0.5 THEN w1_17=-UNIFORM(13+k)/10; ELSE w1_17=UNIFORM(13+k)/10;
IF UNIFORM(14+k)<=0.5 THEN w1_27=-UNIFORM(14+k)/10; ELSE w1_27=UNIFORM(14+k)/10;
IF UNIFORM(15+k)<=0.5 THEN w1_18=-UNIFORM(15+k)/10; ELSE w1_18=UNIFORM(15+k)/10;
IF UNIFORM(16+k)<=0.5 THEN w1_28=-UNIFORM(16+k)/10; ELSE w1_28=UNIFORM(16+k)/10;

/* FIRST LINEAR TRANSFORMATION */
z1=w1_11*x1+w1_21*x4;  z2=w1_12*x1+w1_22*x4; 

/* FIRST ACTIVITY FUNCTION */
IF UNIFORM(17+k)<=0.5 THEN b1=-UNIFORM(17+k)/10; ELSE b1=UNIFORM(17+k)/10;
IF UNIFORM(18+k)<=0.5 THEN b2=-UNIFORM(18+k)/10; ELSE b2=UNIFORM(18+k)/10;
IF UNIFORM(19+k)<=0.5 THEN b3=-UNIFORM(19+k)/10; ELSE b3=UNIFORM(19+k)/10;
IF UNIFORM(20+k)<=0.5 THEN b4=-UNIFORM(20+k)/10; ELSE b4=UNIFORM(20+k)/10;
IF UNIFORM(21+k)<=0.5 THEN b5=-UNIFORM(21+k)/10; ELSE b5=UNIFORM(21+k)/10; 
IF UNIFORM(22+k)<=0.5 THEN b6=-UNIFORM(22+k)/10; ELSE b6=UNIFORM(22+k)/10;
IF UNIFORM(23+k)<=0.5 THEN b7=-UNIFORM(23+k)/10; ELSE b7=UNIFORM(23+k)/10;
IF UNIFORM(24+k)<=0.5 THEN b8=-UNIFORM(24+k)/10; ELSE b8=UNIFORM(24+k)/10;

s1=1/(1+exp(-z1+b1)); s2=1/(1+exp(-z2+b2));

/* SECOND LINEAR TRANSFORMATION */ 

IF UNIFORM(27+k)<=0.5 THEN w2_12=-UNIFORM(27+k)/10; ELSE w2_12=UNIFORM(27+k)/10;
IF UNIFORM(28+k)<=0.5 THEN w2_22=-UNIFORM(28+k)/10; ELSE w2_22=UNIFORM(28+k)/10;
IF UNIFORM(29+k)<=0.5 THEN w2_13=-UNIFORM(29+k)/10; ELSE w2_13=UNIFORM(29+k)/10;
IF UNIFORM(30+k)<=0.5 THEN w2_23=-UNIFORM(30+k)/10; ELSE w2_23=UNIFORM(30+k)/10;
IF UNIFORM(31+k)<=0.5 THEN w2_14=-UNIFORM(31+k)/10; ELSE w2_14=UNIFORM(31+k)/10;
IF UNIFORM(32+k)<=0.5 THEN w2_24=-UNIFORM(32+k)/10; ELSE w2_24=UNIFORM(32+k)/10;

IF UNIFORM(33+k)<=0.5 THEN w2_15=-UNIFORM(33+k)/10; ELSE w2_15=UNIFORM(33+k)/10;
IF UNIFORM(34+k)<=0.5 THEN w2_25=-UNIFORM(34+k)/10; ELSE w2_25=UNIFORM(34+k)/10;
IF UNIFORM(35+k)<=0.5 THEN w2_16=-UNIFORM(35+k)/10; ELSE w2_16=UNIFORM(35+k)/10;
IF UNIFORM(36+k)<=0.5 THEN w2_26=-UNIFORM(36+k)/10; ELSE w2_26=UNIFORM(36+k)/10;
IF UNIFORM(37+k)<=0.5 THEN w2_17=-UNIFORM(37+k)/10; ELSE w2_17=UNIFORM(37+k)/10;
IF UNIFORM(38+k)<=0.5 THEN w2_27=-UNIFORM(38+k)/10; ELSE w2_27=UNIFORM(38+k)/10;
IF UNIFORM(39+k)<=0.5 THEN w2_18=-UNIFORM(39+k)/10; ELSE w2_18=UNIFORM(39+k)/10;
IF UNIFORM(40+k)<=0.5 THEN w2_28=-UNIFORM(40+k)/10; ELSE w2_28=UNIFORM(40+k)/10;

IF UNIFORM(25+k)<=0.5 THEN w2_11=-UNIFORM(25+k)/10; ELSE w2_11=UNIFORM(25+k)/10;
IF UNIFORM(26+k)<=0.5 THEN w2_21=-UNIFORM(26+k)/10; ELSE w2_21=UNIFORM(26+k)/10;
IF UNIFORM(41+k)<=0.5 THEN w2_31=-UNIFORM(41+k)/10; ELSE w2_31=UNIFORM(41+k)/10;
IF UNIFORM(42+k)<=0.5 THEN w2_41=-UNIFORM(42+k)/10; ELSE w2_41=UNIFORM(42+k)/10;
IF UNIFORM(43+k)<=0.5 THEN w2_51=-UNIFORM(43+k)/10; ELSE w2_51=UNIFORM(43+k)/10;
IF UNIFORM(44+k)<=0.5 THEN w2_61=-UNIFORM(44+k)/10; ELSE w2_61=UNIFORM(44+k)/10;
IF UNIFORM(45+k)<=0.5 THEN w2_71=-UNIFORM(45+k)/10; ELSE w2_71=UNIFORM(45+k)/10;
IF UNIFORM(47+k)<=0.5 THEN w2_81=-UNIFORM(47+k)/10; ELSE w2_81=UNIFORM(47+k)/10;

z3=w2_11*s1+w2_21*s2; 
s3=1/(1+exp(-z3+b3));
y_hat=s3; 

/* 1ST BACKPROPAGATION step 1(right hand size) */
pLpw2_11=-2*(y-y_hat)*s3*(1-s3)*s1;
pLpw2_21=-2*(y-y_hat)*s3*(1-s3)*s2;

pLpb3=-2*(y-y_hat)*(s3*(1-s3))*1;

/* new wights ws_11 etc p13 */
w2_11=w2_11-eta*pLpw2_11; w2_21=w2_21-eta*pLpw2_21; 

b3=b3-eta*pLpb3; 

y_hat=s3; 

/* BACKPROPAGATION step 2(left hand size) */


/* 2. BACKPROPAGATION step 2(left hand side)  */

pLpw1_11=-2*(y-y_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y_hat)*(w2_11*s3*(1-s3))*(x4*s1*(1-s1)); 
pLpw1_12=-2*(y-y_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2)); 
pLpw1_22=-2*(y-y_hat)*(w2_21*s3*(1-s3))*(x4*s2*(1-s2)); 

pLpb_1=-2*(y-y_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb_2=-2*(y-y_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

/* SECOND STEP UPDATED WEIGHTS */
w1_11=w1_11-eta*pLpw1_11; w1_21=w1_21-eta*pLpw1_21;
w1_12=w1_12-eta*pLpw1_12; w1_22=w1_22-eta*pLpw1_22;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb_1;                                    
b2=b2-eta*pLpb_2; 

z1=w1_11*x1+w1_21*x4;
z2=w1_12*x1+w1_22*x4;

s1=exp(-z1+b1);  
s2=exp(-z2+b2);

z3=w2_11*s1+w2_21*s2; 
s3=1/(1+exp(-(z3+b3)));   
y1_hat=s3; 

/* proc print; var b8s zs1 ss1 ss2 zs9 ss9 y1_hat; 
run; */

Rx1=x1*(4811.14-1681.61)+1681.61;
Ry=y*(4811.14-1681.61)+1681.61;
Ry_hat=y_hat*(4811.14-1681.61)+1681.61;
Ry1_hat=y1_hat*(4811.14-1681.61)+1681.61;

              x=1; 
              DO WHILE(x<=1000);  

/* 2ND BACKPROPAGATION step 1(right hand size) */
pLpw2_11=-2*(y-y1_hat)*s3*(1-s3)*s1; 
pLpw2_21=-2*(y-y1_hat)*s3*(1-s3)*s2;

pLpb3=-2*(y-y1_hat)*(s3*(1-s3))*1;

/* new wights w_11 etc */
w2_11=w2_11-eta*pLpw2_11; w2_21=w2_21-eta*pLpw2_21; 

b3=b3-eta*pLpb3; 

/* BACKPROPAGATION step 2(left hand size) */
pLpw1_11=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1));
pLpw1_21=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(x4*s1*(1-s1));
pLpw1_12=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(x4*s2*(1-s2));

pLpb_1=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb_2=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

/* SECOND STEP UPDATED WEIGHTS  */
w1_11=w1_11-eta*pLpw1_11; w1_21=w1_21-eta*pLpw1_21; 
w1_12=w1_12-eta*pLpw1_12; w1_22=w1_22-eta*pLpw1_22;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb_1;                                
b2=b2-eta*pLpb_2; 

z1=w1_11*x1+w1_21*x4;
z2=w1_12*x1+w1_22*x4;

s1=exp(-z1+b1);  
s2=exp(-z2+b2);
 
z3=w2_11*s1+w2_21*s2; 
 
s3=1/(1+exp(-(z3+b3)));
y2_hat=s3; 

Rx1=x1*(4191.43-1684.61)+1684.61;
Ry=y*(4191.43-1684.61)+1684.61;
Ry_hat=y_hat*(4191.43-1684.61)+1684.61;
Ry1_hat=y1_hat*(4191.43-1684.61)+1684.61;
Ry2_hat=y2_hat*(4191.43-1684.61)+1684.61; 
 
MSE=(y-y_hat)**2;                       
MSE1=(y-y1_hat)**2;                     
MSE2=(y-y2_hat)**2;

MAE=ABS(y-y_hat);
MAE1=ABS(y-y1_hat);
MAE2=ABS(y-y2_hat);

    MASE_aa=ABS(y-lag4(y));
MASE=MAE/0.0411041;    /* x=1: MASE_aa=0.0411041   */   
MASE1=MAE1/0.0948600;  /* x=2: MASE_aa=0.0948600   */ 
MASE2=MAE2/0.0034228;  /* x=100: MASE_aa=0.0034228 */  


RMSE=SQRT(MSE);
RMSE1=SQRT(MSE1);
RMSE2=SQRT(MSE2);


IF y=0 THEN y=0.001;
MPE=((y-y_hat)/y)*100;
MPE1=((y-y1_hat)/y)*100;
MPE2=((y-y1_hat)/y)*100; 

MAPE=(ABS(y-y_hat)/y)*100;
MAPE1=(ABS(y-y1_hat)/y)*100;
MAPE2=(ABS(y-y2_hat)/y)*100; 

             OUTPUT;
             x+1;
             END; 
             RUN;  

/* IF x<1 THEN DELETE; */
/* PROC PRINT; VAR t x y_hat y1_hat y2_hat;
RUN; */

/*
PROC PRINT; VAR MASE_aa;
RUN; */

PROC MEANS;	VAR MASE_aa;
RUN; 

PROC MEANS; VAR MSE MSE1 MSE2;
RUN;

PROC MEANS; VAR MASE MASE1 MASE2;
RUN;

PROC MEANS; VAR MAE MAE1 MAE2;
RUN;

PROC MEANS; VAR MPE MPE1 MPE2;
RUN;

PROC MEANS; VAR MAPE MAPE1 MAPE2;
RUN;

DATA NEW1;
SET INCOMEDATA; 

/* x1=exp(x1); x2=exp(x2); x3=exp(x3); x4=exp(x4); */
 
SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

/*
PROC GPLOT DATA=INCOMEDATA;   
PLOT y*t=4 y_hat*t=1 y1_hat*t=2 y2_hat*t=3 /OVERLAY legend GRID FRAME HREF=97.5;
RUN;

PROC GPLOT DATA=INCOMEDATA;   
PLOT y*t=4 y_hat*t=2 y1_hat*t=3 /OVERLAY legend GRID FRAME HREF=97.5;
RUN;

PROC GPLOT DATA=INCOMEDATA;   
PLOT y*t=1 y1_hat*t=2 /OVERLAY 
legend GRID FRAME HREF=97.5; 
RUN;

PROC GPLOT DATA=INCOMEDATA;   
PLOT y*t=1 y2_hat*t=3 /OVERLAY 
legend GRID FRAME HREF=97.5; 
RUN; 
*/


/* x1=exp(x1); x2=exp(x2); x3=exp(x3); x4=exp(x4); x5=exp(x5); */

/*
PROC PRINT DATA=INCOMEDATA; VAR t s9 Ry y_hat y1_hat y2_hat y3_hat y4_hat mse1 mse2 mse3 mse4;
RUN; 

PROC PRINT DATA=INCOMEDATA; VAR t y_hat y1_hat y2_hat y3_hat y4_hat;
RUN; 

PROC PRINT DATA=INCOMEDATA; VAR t Ry Ry_hat Ry1_hat Ry2_hat Ry3_hat Ry4_hat;
RUN; 
*/

/*
DATA NEW1;
INFILE 'G:\FSAScodedata_2010\INCOMES9.dat'; 
INPUT x1 x2 x3 x4 x5 @@;   
t=_N_;

DATA NEW2;
SET INCOMEDATA NEW1; */