DATA sunspot;
INFILE 'G:\BOX-ANN\SUNSPOT.dat';
INPUT SUN @@;
t=_N_;

PROC PRINT; VAR t SUN;
RUN; 

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=spline ci=black; 

PROC GPLOT; 
PLOT SUN*t=4/ /* VREF=0*/ GRID FRAME  VAXIS=0  TO 200 BY 20 HAXIS=0 TO 460 BY 50;
symbol c=black v= i=join;
RUN;

