DATA DATA0;                     
INFILE 'G:\BOX-ANN\SUN5.dat';   /* SUNSPOT.dat */
INPUT x;           /* x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 @@; */
t=_N_;

/* proc print; var x;
run; */

PROC AUTOREG;
MODEL x=/nlag=2;
RUN;

PROC AUTOREG;
MODEL x=/nlag=3;
RUN;

PROC AUTOREG;
MODEL x=/nlag=6;
RUN;

PROC AUTOREG;
MODEL x=/nlag=15;
RUN;

PROC ARIMA;
IDENTIFY VAR=x nlags=36;
ESTIMATE p=1;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x nlags=36;
ESTIMATE p=2;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x nlags=36;
ESTIMATE p=3;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x nlags=36;
ESTIMATE p=4;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x nlags=36;
ESTIMATE p=15;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x(10) nlags=36;
ESTIMATE p=1;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x(10) nlags=36;
ESTIMATE p=2;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x(10) nlags=36;
ESTIMATE p=3;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x(10) nlags=36;
ESTIMATE p=4;
RUN; 

PROC ARIMA;
IDENTIFY VAR=x(10) nlags=36;
ESTIMATE p=15;
RUN; 

PROC AUTOREG;
MODEL x=/nlag=6;
RUN;

DATA DATA1;
SET DATA0;
DATA10=DIF10(x);
DATA1011=DIF11(DATA10);
RUN;

PROC AUTOREG;
MODEL DATA10=/nlag=3;
RUN;

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=DATA0;   
PLOT x*t=4 /OVERLAY legend GRID FRAME HREF=444.5; 
/* HAXIS=0 TO 500 BY 50; */ 
RUN; 

PROC GPLOT DATA=DATA1;
PLOT DATA10*t=4 /OVERLAY legend GRID FRAME HREF=444.5 
VREF=0 VAXIS=-500 TO 500 BY 50 HAXIS=0 TO 500 BY 50; 
RUN; 

PROC GPLOT DATA=DATA1;
PLOT DATA1011*t=4 /OVERLAY legend GRID FRAME HREF=444.5 
VREF=0 VAXIS=-500 TO 500 BY 50 HAXIS=0 TO 500 BY 50; 
RUN; 



