DATA SASd2; 
INPUT Lag SACF SE;
twoSE=1.96*SE;
ntwoSE=(-1)* twoSE;
SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=join ci=black;
SYMBOL4 v=none cv=black i=line ci=black;
LINES;  /* Ʒ SAS-[6]-2 1-а迭  PROC ARIMA . */ 
                    0        1.00000              0
                    1        -.43396       0.140028
                    2        0.11902       0.164295
                    3        -.25998       0.165977
                    4        0.17914       0.173779
                    5        -.04407       0.177363
                    6        -.00380       0.177577
                    7        -.07222       0.177579
                    8        -.12208       0.178154
                    9        0.25191       0.179787
                   10        -.01273       0.186579
                   11        -.02306       0.186596
                   12        -.12513       0.186652
                   13        0.09940       0.188290
                   14        -.01387       0.189316
                   15        -.02875       0.189336
                   16        0.03957       0.189421
                   17        -.16794       0.189583
                   18        -.00624       0.192478
                   19        0.08558       0.192482
                   20        0.07727       0.193227
                   21        0.02140       0.193832
                   22        -.03481       0.193878
                   23        0.04346       0.194001
                   24        -.07638       0.194191
                   25        0.13599       0.194780
                   26        -.11013       0.196632
                   27        -.10303       0.197838
                   28        0.02921       0.198887
                   29        0.20197       0.198971
                   30        -.06329       0.202952
                   31        -.10118       0.203338
                   32        0.03351       0.204323
                   33        -.02346       0.204431
                   34        0.06879       0.204484
                   35        0.02702       0.204937
                   36        -.14064       0.205007
                   37        0.03157       0.206890
                   38        0.01436       0.206984
                   39        0.02775       0.207004
                   40        -.04953       0.207077
                   41        -.01983       0.207309
                   42        0.05177       0.207346
                   43        -.00765       0.207600
                   44        0.02884       0.207605
                   45        -.00129       0.207684
                   46        -.05952       0.207684
                   47        0.03922       0.208018
                   48        -.00428       0.208163
                   49        -.00324       0.208165
                   50        0.00532       0.208166
;
PROC GPLOT DATA=SASd2;
PLOT SACF*Lag=1 twoSE*Lag=4 ntwoSE*Lag=4 / /*VREF=0 HREF=0*/
OVERLAY grid frame VREF=0 vaxis=-1.0 to 1.0 by 0.2 haxis=0 to 51 by 2;
RUN;

DATA SASd2; 
INPUT Lag SPACF SE;
twoSE=1.96*SE;
ntwoSE=(-1)* twoSE;
SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=join ci=black;
SYMBOL4 v=none cv=black i=line ci=black;
LINES;      /* 1.96* 1/\SQRT{52}=1.96*0.140028=0.271803 */   
                                  1       -0.43396     0.140028
                                  2       -0.08537     0.140028
                                  3       -0.29906     0.140028
                                  4       -0.07197     0.140028
                                  5       -0.00781     0.140028
                                  6       -0.08853     0.140028
                                  7       -0.10642     0.140028
                                  8       -0.28404     0.140028
                                  9        0.05674     0.140028
                                 10        0.12205     0.140028
                                 11       -0.01905     0.140028
                                 12       -0.05995     0.140028
                                 13        0.00464     0.140028
                                 14       -0.02076     0.140028
                                 15       -0.10270     0.140028
                                 16        0.05277     0.140028
                                 17       -0.12276     0.140028
                                 18       -0.30375     0.140028
                                 19       -0.14784     0.140028
                                 20       -0.02615     0.140028
                                 21        0.11613     0.140028
                                 22        0.06071     0.140028
                                 23        0.06914     0.140028
                                 24       -0.02537     0.140028
                                 25        0.05391     0.140028
                                 26        0.08612     0.140028
                                 27       -0.06317     0.140028
                                 28       -0.02335     0.140028
                                 29        0.15918     0.140028
                                 30        0.03003     0.140028
                                 31       -0.12039     0.140028
                                 32       -0.02445     0.140028
                                 33       -0.03436     0.140028
                                 34       -0.10314     0.140028
                                 35        0.03980     0.140028
                                 36       -0.01779     0.140028
                                 37        0.07041     0.140028
                                 38       -0.00445     0.140028
                                 39       -0.07605     0.140028
                                 40        0.07715     0.140028
                                 41       -0.06429     0.140028
                                 42       -0.05887     0.140028
                                 43       -0.01433     0.140028
                                 44       -0.10330     0.140028
                                 45       -0.03039     0.140028
                                 46       -0.03969     0.140028
                                 47        0.07505     0.140028
                                 48       -0.03306     0.140028
                                 49       -0.11937     0.140028
                                 50       -0.04134     0.140028
;                             
PROC PRINT;
RUN;
PROC GPLOT DATA=SASd2;
PLOT SPACF*Lag=1 twoSE*Lag=4 ntwoSE*Lag=4 / /*VREF=0 HREF=0*/
OVERLAY grid frame VREF=0 vaxis=-1.0 to 1.0 by 0.2 haxis=1 to 51 by 2;
RUN;
