DATA SASd2;  
INPUT Lag  SACF  SE;
twoSE=1.96*SE;
ntwoSE=(-1)*twoSE;
 
SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=join ci=black;
SYMBOL4 v=none cv=black i=line ci=black;
 
LINES;
                    0             1.00000             0
                    1             0.76810      0.074536
                    2             0.54800      0.110049
                    3             0.35842      0.124288
                    4             0.26384      0.129904
                    5             0.14675      0.132848
                    6             0.13880      0.133745
                    7             0.13557      0.134543
                    8             0.23719      0.135300
                    9             0.31672      0.137590
                   10             0.47666      0.141583
                   11             0.66211      0.150234
                   12             0.84273      0.165654
                   13             0.65224      0.187969
                   14             0.44378      0.200148
                   15             0.26700      0.205542
                   16             0.18036      0.207460
                   17             0.07503      0.208329
                   18             0.05809      0.208479
                   19             0.04972      0.208569
                   20             0.14164      0.208635
                   21             0.21562      0.209168
                   22             0.37748      0.210400
                   23             0.55266      0.214129
                   24             0.72269      0.221912
;
PROC PRINT;
RUN;
PROC GPLOT DATA=SASd2;
PLOT SACF*Lag=1  twoSE*Lag=4  ntwoSE*Lag=4/ VREF=0 /* HREF=0 */
         OVERLAY grid  frame  vaxis=-1.0  to 1.0  by 0.2  haxis=0 to 24 by 1;
RUN;

DATA SASd2;  
INPUT Lag  PSACF  SE;
twoSE=1.96*SE;
ntwoSE=(-1)* twoSE;
 
SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=join ci=black;
SYMBOL4 v=none cv=black i=line ci=black;
 
LINES;
                                  1        0.76810   0.074535
                                  2       -0.10238   0.074535
                                  3       -0.06643   0.074535
                                  4        0.09677   0.074535
                                  5       -0.13746   0.074535
                                  6        0.18542   0.074535
                                  7        0.00089   0.074535
                                  8        0.25020   0.074535
                                  9        0.09188   0.074535
                                 10        0.31866   0.074535
                                 11        0.44176   0.074535
                                 12        0.47202   0.074535
                                 13       -0.54267   0.074535
                                 14       -0.14513   0.074535
                                 15       -0.00228   0.074535
                                 16       -0.02732   0.074535
                                 17       -0.00459   0.074535
                                 18       -0.09362   0.074535
                                 19       -0.05646   0.074535
                                 20       -0.00355   0.074535
                                 21       -0.01385   0.074535
                                 22        0.14788   0.074535
                                 23        0.04405   0.074535
                                 24        0.12496   0.074535
;
PROC PRINT;
RUN;
PROC GPLOT DATA=SASd2;
PLOT PSACF*Lag=1  twoSE*Lag=4  ntwoSE*Lag=4/VREF=0 /* HREF=0 */ 
         OVERLAY grid  frame  vaxis=-1.0  to 1.0  by 0.2  haxis=1 to 24 by 1;
RUN;
