DATA SASd2; 
INPUT Lag  SACF  SE; 
twoSE=1.96*SE; ntwoSE=(-1)*twoSE;

SYMBOL1 v=dot cv=black i=line ci=black; SYMBOL2 v=circle cv=black
i=spline ci=black; SYMBOL3 v=none cv=black i=join ci=black;
SYMBOL4 v=none cv=black i=line ci=black;

LINES;
                    0          1.00000             0
                    1          0.20009      0.077152
                    2          0.03758      0.080181
                    3          -.01642      0.080286
                    4          -.13195      0.080306
                    5          -.15527      0.081586
                    6          -.16452      0.083326
                    7          -.08719      0.085238
                    8          -.01950      0.085767
                    9          0.08105      0.085794
                   10          0.10809      0.086248
                   11          0.10802      0.087051
                   12          0.02470      0.087845
                   13          0.10055      0.087886
                   14          0.03112      0.088568
                   15          0.00802      0.088633
                   16          -.08842      0.088638
                   17          0.05053      0.089161
                   18          -.07328      0.089332
                   19          -.12791      0.089689
                   20          -.04751      0.090768
                   21          -.12599      0.090916
                   22          0.11020      0.091949
                   23          0.08917      0.092732
                   24          0.01899      0.093241
;
PROC PRINT; 
RUN; 

PROC GPLOT DATA=SASd2; 
PLOT SACF*Lag=1 twoSE*Lag=4 ntwoSE*Lag=4 /VREF=0 /* HREF=0 */
         OVERLAY grid  frame  vaxis=-1.0  to 1.0  by 0.2  haxis=0 to 24 by 2;
RUN;

DATA SASd2; 
INPUT Lag  SACF  SE; 
twoSE=1.96*SE; ntwoSE=(-1)*twoSE;

SYMBOL1 v=dot cv=black i=line ci=black; SYMBOL2 v=circle cv=black
i=spline ci=black; SYMBOL3 v=none cv=black i=join ci=black;
SYMBOL4 v=none cv=black i=line ci=black;

LINES;
                    0          1.00000             0
                    1          0.15917      0.077152
                    2          0.00126      0.079082
                    3          -.00335      0.079082
                    4          -.11182      0.079083
                    5          -.10612      0.080019
                    6          -.11219      0.080852
                    7          -.02033      0.081774
                    8          0.01051      0.081804
                    9          0.06553      0.081812
                   10          0.11561      0.082124
                   11          0.05953      0.083087
                   12          -.02666      0.083340
                   13          0.03197      0.083391
                   14          -.02878      0.083464
                   15          0.03589      0.083523
                   16          -.06137      0.083615
                   17          0.09749      0.083882
                   18          -.04913      0.084554
                   19          -.11685      0.084724
                   20          -.00468      0.085678
                   21          -.11626      0.085679
                   22          0.09964      0.086613
                   23          0.06172      0.087293
                   24          -.05757      0.087552
;

PROC PRINT; RUN; 
PROC GPLOT DATA=SASd2; 
PLOT SACF*Lag=1
twoSE*Lag=4  ntwoSE*Lag=4 / VREF=0 /* HREF=0 */
         OVERLAY grid  frame  vaxis=-1.0  to 1.0  by 0.2  haxis=0 to 24 by 2;
RUN;
