DATA analy;
INFILE 'G:\BOX-ANN\EXPORTS.dat'; 
INPUT q exports @@;
t=_N_;
DATE=INTNX('quarter','1jan58'd,_N_-1); 
format date yyq5.;

exports_c=exports-1141.87;      /* _c means centered  */
DIFF1=dif1(exports);
DIFF4=dif4(exports);
DIFF1_c=DIFF1-20.0268293;
DIFF4_c=DIFF4-75.4263;          /* -3.8889842;*/
DIFF_c4=dif4(exports_c);
DIFF_c4D1=dif1(DIFF_c4);

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i= spline ci=black;

PROC PRINT;
RUN;

PROC MEANS MEAN VAR STD MIN MAX N; 
RUN;

/*
PROC GPLOT DATA=analy;
PLOT exports*date=1/VREF=1141.87 grid frame vaxis=600 to 1600 by 100 
haxis='01jan58'd to '01apr68'd by quarter;
RUN;

PROC ARIMA;
IDENTIFY VAR=exports NLAG=36;
RUN;

PROC GPLOT DATA=analy;
PLOT DIFF1*date=1/VREF=20.02 grid frame vaxis=-500 to 500 by 50 
haxis='01jan58'd to '01apr68'd by quarter;
RUN;
*/

PROC ARIMA;
IDENTIFY VAR=DIFF1 NLAG=36;
RUN;

/*
PROC GPLOT DATA=analy;
PLOT DIFF4*date=1/VREF=75.4263 grid frame vaxis=-500 to 500 by 50 
haxis='01jan58'd to '01apr68'd by quarter;
RUN; */

PROC ARIMA DATA=analy;
IDENTIFY VAR=DIFF_c4D1 NLAG=36;
ESTIMATE P=(1)(0) Q=(0)(4) METHOD=ml;         
FORECAST LEAD=5 OUT=out2;
RUN;


